//Generation Date: Wed Nov 21 15:53:27 CET 2007
package com.termcat.bd.beans.skels;

import java.sql.*;
import java.io.*;
import java.util.Vector;
import java.util.List;
import com.termcat.bd.utils.DBConnect;
import com.termcat.bd.exceptions.*;
import electric.xml.*;

import java.util.*;
import java.text.*;

/**
  * CategoriesSkel
  * Clase para acceder a BD
  * DBTable: co_categories
  * @author collazos
  * -----------------------------------------
  * Database version : 1.0 (2007-04-29)
  * Driver Name : H2 JDBC Driver
  * Driver Version : 1.0
  * Generator version : 2.2.0
  * Generation Date : Wed Nov 21 15:53:27 CET 2007
  * @todo extends this class always !!!
  * 
  */
public class CategoriesSkel implements Serializable, Comparable {
  public final static String TABLE_NAME = "co_categories"; // (Alias from: co_categories)
  private boolean dirty = false;
  private boolean valid = true;
  public static int numFields = 4;

  /**
   * Random Generated UID for this serializable class
   * <code>serialVersionUID</code>
   */
  private static final long serialVersionUID =-4464494150294315977L;

  public static final long NULL_LONG =9223372036854775807L;
  public static final double NULL_DOUBLE =1.7976931348623157E308;
  public static final int NULL_INT =2147483647;
  public static final short NULL_SHORT =32767;
  public static final float NULL_FLOAT =3.4028235E38f;

  /**
   * Dirty flags for all fields
   */
 private boolean[] dirtyFields = {false,false,false,false};
 private final boolean[] dirtyFieldsDefault = {false,false,false,false};

  public CategoriesSkel(String idCategoria,String codiCategoria,String descripcio,long prioritat) {
    this.idCategoria = idCategoria;
    this.codiCategoria = codiCategoria;
    this.descripcio = descripcio;
    this.prioritat = prioritat;
  }

  public CategoriesSkel(String idCategoria) {
    this.idCategoria = idCategoria;
  }

  public CategoriesSkel() { 
  }

  /**
    * Type : VARCHAR Name : ID_CATEGORIA
    */
    private String idCategoria;

  /**
    * Type : VARCHAR Name : CODI_CATEGORIA
    */
    private String codiCategoria;

  /**
    * Type : VARCHAR Name : DESCRIPCIO
    */
    private String descripcio;

  /**
    * Type : BIGINT Name : PRIORITAT
    */
    private long prioritat;

  /**
    * Sets the value for idCategoria
    * @param idCategoria
    */
  public void setIdCategoria(String idCategoria) {
    if (idCategoria.length() > 64)
      this.idCategoria=idCategoria.substring(0,64);
    else this.idCategoria=idCategoria;
    this.dirty = true;
    dirtyFields[0] = true;
  }

  /**
    * Gets the value for idCategoria
    */
  public String getIdCategoria() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idCategoria;
  }

  /**
    * Sets the value for codiCategoria
    * @param codiCategoria
    */
  public void setCodiCategoria(String codiCategoria) {
    if (codiCategoria.length() > 300)
      this.codiCategoria=codiCategoria.substring(0,300);
    else this.codiCategoria=codiCategoria;
    this.dirty = true;
    dirtyFields[1] = true;
  }

  /**
    * Gets the value for codiCategoria
    */
  public String getCodiCategoria() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return codiCategoria;
  }

  /**
    * Sets the value for descripcio
    * @param descripcio
    */
  public void setDescripcio(String descripcio) {
    if (descripcio.length() > 500)
      this.descripcio=descripcio.substring(0,500);
    else this.descripcio=descripcio;
    this.dirty = true;
    dirtyFields[2] = true;
  }

  /**
    * Gets the value for descripcio
    */
  public String getDescripcio() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return descripcio;
  }

  /**
    * Sets the value for prioritat
    * @param prioritat
    */
  public void setPrioritat(long prioritat) {
    this.prioritat=prioritat;
    this.dirty = true;
    dirtyFields[3] = true;
  }

  /**
    * Gets the value for prioritat
    */
  public long getPrioritat() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return prioritat;
  }

/**
  * Return a boolean if the element with PK exists.
  */
public boolean exists(String idCategoria)  {
  boolean exists = false;
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  try {
    String sql="SELECT * FROM CO_CATEGORIES" +" where ID_CATEGORIA="+formatString(idCategoria);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    if (rs.next()) {
      exists = true;
    }
  } catch (Exception e) {
    exists = false;
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
  return exists;
}

/**
  * Inserts to the database for table "co_categories"
  */
public void create(Connection con) throws CreateException {
  Statement stm = null;
  try {
    String sql="INSERT INTO co_categories (ID_CATEGORIA,CODI_CATEGORIA,DESCRIPCIO,PRIORITAT) VALUES ("+formatString(idCategoria)+","+formatString(codiCategoria)+","+formatString(descripcio)+","+formatLong(prioritat)+")";
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new CreateException("Error inserting row");
  } catch (Exception e) {
    throw new CreateException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Inserts to the database for table "co_categories"
  */
public void create() throws CreateException {
  Connection con = null;
  Statement stm = null;
  try {
    String sql="INSERT INTO co_categories (ID_CATEGORIA,CODI_CATEGORIA,DESCRIPCIO,PRIORITAT) VALUES ("+formatString(idCategoria)+","+formatString(codiCategoria)+","+formatString(descripcio)+","+formatLong(prioritat)+")";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new CreateException("Error inserting row");
  } catch (Exception e) {
    throw new CreateException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Updates the current object values into the database.
  */
protected void store(Connection con) throws StoreException {
  if (!dirty)
    return;
  if (!isGlobalDirty())
    return;
  Statement stm = null;
  try {
    String sql="UPDATE co_categories set ";
    int idx = 0;
    if (dirtyFields[idx++]) {
      sql+="ID_CATEGORIA="+formatString(idCategoria)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="CODI_CATEGORIA="+formatString(codiCategoria)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="DESCRIPCIO="+formatString(descripcio)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="PRIORITAT="+formatLong(prioritat)+",";
    }
    sql=sql.substring(0,sql.length()-1);
    sql=sql+" where ID_CATEGORIA="+formatString(idCategoria);
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1) {
      throw new StoreException("Error updating row");
    }
    dirty = false;
    valid = true;
    dirtyFields = dirtyFieldsDefault;
  } catch (Exception e) {
  throw new StoreException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Updates the current object values into the database.
  */
protected void store() throws StoreException {
  if (!dirty)
    return;
  if (!isGlobalDirty())
    return;
  Connection con = null;
  Statement stm = null;
  try {
    String sql="UPDATE co_categories set ";
    int idx = 0;
    if (dirtyFields[idx++]) {
      sql+="ID_CATEGORIA="+formatString(idCategoria)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="CODI_CATEGORIA="+formatString(codiCategoria)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="DESCRIPCIO="+formatString(descripcio)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="PRIORITAT="+formatLong(prioritat)+",";
    }
    sql=sql.substring(0,sql.length()-1);
    sql=sql+" where ID_CATEGORIA="+formatString(idCategoria);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1) {
      throw new StoreException("Error updating row");
    }
    dirty = false;
    valid = true;
    dirtyFields = dirtyFieldsDefault;
  } catch (Exception e) {
  throw new StoreException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Deletes from the database for table "co_categories"
  */
public void remove(Connection con) throws RemoveException {
  Statement stm = null;
  try {
    String sql="DELETE FROM co_categories WHERE ID_CATEGORIA="+formatString(idCategoria);
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new RemoveException("Error deleting row");
  } catch (Exception e) {
    throw new RemoveException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Deletes from the database for table "co_categories"
  */
public void remove() throws RemoveException {
  Connection con = null;
  Statement stm = null;
  try {
    String sql="DELETE FROM co_categories WHERE ID_CATEGORIA="+formatString(idCategoria);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new RemoveException("Error deleting row");
  } catch (Exception e) {
    throw new RemoveException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

public int compareTo(Object o) {
  CategoriesSkel cn = (CategoriesSkel) o;
  int result = 0;
  result = this.idCategoria.compareTo(cn.idCategoria);
  if (result != 0) { return result; };
  result = this.codiCategoria.compareTo(cn.codiCategoria);
  if (result != 0) { return result; };
  result = this.descripcio.compareTo(cn.descripcio);
  if (result != 0) { return result; };
  result = (new Long(this.prioritat).compareTo(new Long(cn.prioritat)));
  if (result != 0) { return result; };
  return result;
}
/**
  * Finds and return the object of this PK.
  */
public CategoriesSkel findByPrimaryKey(String idCategoria) throws FinderException {
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  try {
    String sql="SELECT * FROM CO_CATEGORIES" +" where ID_CATEGORIA="+formatString(idCategoria);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    if (!rs.next()) {
      throw new FinderException("Primary Key not found");
    }
    this.idCategoria = rs.getString("ID_CATEGORIA");
    this.codiCategoria = rs.getString("CODI_CATEGORIA");
    this.descripcio = rs.getString("DESCRIPCIO");
    this.prioritat = rs.getLong("PRIORITAT");
    return this;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Finds and return a List for a generic where.
  */
public List findByGenericWhere(String where) throws FinderException {
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  List result = new ArrayList();
  try {
    String sql="SELECT * FROM CO_CATEGORIES" +" WHERE "+where;
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    while (rs.next()) {
      CategoriesSkel tmp = (CategoriesSkel) this.getClass().newInstance();
      tmp.idCategoria = rs.getString("ID_CATEGORIA");
      tmp.codiCategoria = rs.getString("CODI_CATEGORIA");
      tmp.descripcio = rs.getString("DESCRIPCIO");
      tmp.prioritat = rs.getLong("PRIORITAT");
      result.add(tmp);
    }
    return result;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

  protected void load() throws LoadException {
  if (valid)
    return;
  try {
    CategoriesSkel cn = findByPrimaryKey(idCategoria);
  cn.setValid(true);
    this.idCategoria = cn.getIdCategoria();
    this.codiCategoria = cn.getCodiCategoria();
    this.descripcio = cn.getDescripcio();
    this.prioritat = cn.getPrioritat();
    dirty = false;
    valid = true;
  } catch (FinderException e) {
     throw new LoadException(e.toString());
  }
}

/**
  * Synchronize the current object values into the database.
  */
public void flush() throws Exception{
  try {
    if (dirty) {
      store();
      dirty = false;
    }
  } catch (Exception e) {
    e.printStackTrace();
  throw e;
  }
}
/**
  * Synchronize the current object values into the database.
  */
public void flush(Connection con) throws Exception{
  try {
    if (dirty) {
      store(con);
      dirty = false;
    }
  } catch (Exception e) {
    e.printStackTrace();
  throw e;
  }
}

  public static String formatString(String st) {
    String stString = "null";
    if (st != null) {
      if (st.indexOf("'") != -1)
        st = BdUtils.replaceString(st,"'","''");
      stString = "'"+st+"'";
    }
    return stString;
  }

  public static String formatTimeStamp(Timestamp ts)  {
    String tsString = "null";
    if (ts!=null) {
        tsString = "'"+ts.toString()+"'";
    }
    return tsString;
  }

  public static String formatInteger(int i) {
    if (i == NULL_INT)
      return "NULL";
    else
      return ""+i;
  }

  public static String formatDouble(double d) {
    if (d == NULL_DOUBLE)
      return "NULL";
    else
      return ""+d;
  }

  public static String formatLong(long l) {
    if (l == NULL_LONG)
      return "NULL";
    else
      return ""+l;
  }

  public static String formatShort(double s) {
    if (s == NULL_SHORT)
      return "NULL";
    else
      return ""+s;
  }

  public static String formatFloat(float f) {
    if (f == NULL_FLOAT)
      return "NULL";
    else
      return ""+f;
  }

  public static String formatDate(java.util.Date d)  {
    String tsString = "null";
    if (d!=null) {
        tsString = "'"+d.toString()+"'";
    }
    return tsString;
  }

  public String toString() {
    String result = "\n";
    result+="idCategoria: "+idCategoria+"\n";
    result+="codiCategoria: "+codiCategoria+"\n";
    result+="descripcio: "+descripcio+"\n";
    result+="prioritat: "+prioritat+"\n";
    return result;
  }


  public Element toXml() {
    Document doc = new Document();
    Element main = doc.addElement("Categories");
    Element elem_1= doc.addElement("idCategoria");
    elem_1.setText(""+(this.getIdCategoria() == null || this.getIdCategoria().equals("null")?"":this.getIdCategoria()));
    main.addChild(elem_1);
    Element elem_2= doc.addElement("codiCategoria");
    elem_2.setText(""+(this.getCodiCategoria() == null || this.getCodiCategoria().equals("null")?"":this.getCodiCategoria()));
    main.addChild(elem_2);
    Element elem_3= doc.addElement("descripcio");
    elem_3.setText(""+(this.getDescripcio() == null || this.getDescripcio().equals("null")?"":this.getDescripcio()));
    main.addChild(elem_3);
    Element elem_4= doc.addElement("prioritat");
    elem_4.setText(""+this.getPrioritat());
    main.addChild(elem_4);
    doc.addChild(main);
    return doc.getRoot();

  }


  public boolean isDirty() {
    return this.dirty;
  }

  public boolean isValid() {
    return this.valid;
  }

  public void setDirty(boolean dirty) {
    this.dirty = dirty;
    if (this.dirty == false) dirtyFields = dirtyFieldsDefault;
  }

  public void setValid(boolean valid) {
    this.valid = valid;
  }
  public boolean isGlobalDirty(){
  boolean result = false;
  for (int i=0;i<numFields;i++)
    result=result || dirtyFields[i];
  return result;
  }

public Vector findAll() throws FinderException { 
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  Vector v = new Vector();
  try {
    String sql="SELECT * from co_categories ";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    while (rs.next()) {
      CategoriesSkel tmp=(CategoriesSkel) this.getClass().newInstance();
      tmp.idCategoria = rs.getString("ID_CATEGORIA");
      tmp.codiCategoria = rs.getString("CODI_CATEGORIA");
      tmp.descripcio = rs.getString("DESCRIPCIO");
      tmp.prioritat = rs.getLong("PRIORITAT");
      v.add(tmp);
    }
    return v;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}


public Element findAllXml() { 
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  int k=0;
  try {
    String sql="SELECT * from co_categories ";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    Element queryResult = new Element("query-result");
    while (rs.next()) {
      CategoriesSkel tmp=new CategoriesSkel();
      tmp.idCategoria = rs.getString("ID_CATEGORIA");
      tmp.codiCategoria = rs.getString("CODI_CATEGORIA");
      tmp.descripcio = rs.getString("DESCRIPCIO");
      tmp.prioritat = rs.getLong("PRIORITAT");
      Element tmpElem = tmp.toXml();
      tmpElem.setAttribute("rowid",""+k);
      queryResult.addChild(tmpElem);
      k++;
    }
    return queryResult;
  } catch (Exception e) {
    throw new BaseRuntimeException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}


}
