//Generation Date: Wed Nov 21 15:53:27 CET 2007
package com.termcat.bd.beans.skels;

import java.sql.*;
import java.io.*;
import java.util.Vector;
import java.util.List;
import com.termcat.bd.utils.DBConnect;
import com.termcat.bd.exceptions.*;
import electric.xml.*;

import java.util.*;
import java.text.*;

/**
  * ContextSkel
  * Clase para acceder a BD
  * DBTable: co_context
  * @author collazos
  * -----------------------------------------
  * Database version : 1.0 (2007-04-29)
  * Driver Name : H2 JDBC Driver
  * Driver Version : 1.0
  * Generator version : 2.2.0
  * Generation Date : Wed Nov 21 15:53:27 CET 2007
  * @todo extends this class always !!!
  * 
  */
public class ContextSkel implements Serializable, Comparable {
  public final static String TABLE_NAME = "co_context"; // (Alias from: co_context)
  private boolean dirty = false;
  private boolean valid = true;
  public static int numFields = 6;

  /**
   * Random Generated UID for this serializable class
   * <code>serialVersionUID</code>
   */
  private static final long serialVersionUID =7794635435829732877L;

  public static final long NULL_LONG =9223372036854775807L;
  public static final double NULL_DOUBLE =1.7976931348623157E308;
  public static final int NULL_INT =2147483647;
  public static final short NULL_SHORT =32767;
  public static final float NULL_FLOAT =3.4028235E38f;

  /**
   * Dirty flags for all fields
   */
 private boolean[] dirtyFields = {false,false,false,false,false,false};
 private final boolean[] dirtyFieldsDefault = {false,false,false,false,false,false};

  public ContextSkel(String idContext,String idFitxa,String idDiccionari,String idLlengua,String contextNormal,String contextRtf) {
    this.idContext = idContext;
    this.idFitxa = idFitxa;
    this.idDiccionari = idDiccionari;
    this.idLlengua = idLlengua;
    this.contextNormal = contextNormal;
    this.contextRtf = contextRtf;
  }

  public ContextSkel(String idContext) {
    this.idContext = idContext;
  }

  public ContextSkel() { 
  }

  /**
    * Type : VARCHAR Name : ID_CONTEXT
    */
    private String idContext;

  /**
    * Type : VARCHAR Name : ID_FITXA
    */
    private String idFitxa;

  /**
    * Type : VARCHAR Name : ID_DICCIONARI
    */
    private String idDiccionari;

  /**
    * Type : VARCHAR Name : ID_LLENGUA
    */
    private String idLlengua;

  /**
    * Type : VARCHAR Name : CONTEXT_NORMAL
    */
    private String contextNormal;

  /**
    * Type : VARCHAR Name : CONTEXT_RTF
    */
    private String contextRtf;

  /**
    * Sets the value for idContext
    * @param idContext
    */
  public void setIdContext(String idContext) {
    if (idContext.length() > 64)
      this.idContext=idContext.substring(0,64);
    else this.idContext=idContext;
    this.dirty = true;
    dirtyFields[0] = true;
  }

  /**
    * Gets the value for idContext
    */
  public String getIdContext() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idContext;
  }

  /**
    * Sets the value for idFitxa
    * @param idFitxa
    */
  public void setIdFitxa(String idFitxa) {
    if (idFitxa.length() > 64)
      this.idFitxa=idFitxa.substring(0,64);
    else this.idFitxa=idFitxa;
    this.dirty = true;
    dirtyFields[1] = true;
  }

  /**
    * Gets the value for idFitxa
    */
  public String getIdFitxa() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idFitxa;
  }

  /**
    * Sets the value for idDiccionari
    * @param idDiccionari
    */
  public void setIdDiccionari(String idDiccionari) {
    if (idDiccionari.length() > 64)
      this.idDiccionari=idDiccionari.substring(0,64);
    else this.idDiccionari=idDiccionari;
    this.dirty = true;
    dirtyFields[2] = true;
  }

  /**
    * Gets the value for idDiccionari
    */
  public String getIdDiccionari() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idDiccionari;
  }

  /**
    * Sets the value for idLlengua
    * @param idLlengua
    */
  public void setIdLlengua(String idLlengua) {
    if (idLlengua.length() > 64)
      this.idLlengua=idLlengua.substring(0,64);
    else this.idLlengua=idLlengua;
    this.dirty = true;
    dirtyFields[3] = true;
  }

  /**
    * Gets the value for idLlengua
    */
  public String getIdLlengua() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idLlengua;
  }

  /**
    * Sets the value for contextNormal
    * @param contextNormal
    */
  public void setContextNormal(String contextNormal) {
    if (contextNormal.length() > 9000)
      this.contextNormal=contextNormal.substring(0,9000);
    else this.contextNormal=contextNormal;
    this.dirty = true;
    dirtyFields[4] = true;
  }

  /**
    * Gets the value for contextNormal
    */
  public String getContextNormal() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return contextNormal;
  }

  /**
    * Sets the value for contextRtf
    * @param contextRtf
    */
  public void setContextRtf(String contextRtf) {
    if (contextRtf.length() > 18000)
      this.contextRtf=contextRtf.substring(0,18000);
    else this.contextRtf=contextRtf;
    this.dirty = true;
    dirtyFields[5] = true;
  }

  /**
    * Gets the value for contextRtf
    */
  public String getContextRtf() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return contextRtf;
  }

/**
  * Return a boolean if the element with PK exists.
  */
public boolean exists(String idContext)  {
  boolean exists = false;
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  try {
    String sql="SELECT * FROM CO_CONTEXT" +" where ID_CONTEXT="+formatString(idContext);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    if (rs.next()) {
      exists = true;
    }
  } catch (Exception e) {
    exists = false;
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
  return exists;
}

/**
  * Inserts to the database for table "co_context"
  */
public void create(Connection con) throws CreateException {
  Statement stm = null;
  try {
    String sql="INSERT INTO co_context (ID_CONTEXT,ID_FITXA,ID_DICCIONARI,ID_LLENGUA,CONTEXT_NORMAL,CONTEXT_RTF) VALUES ("+formatString(idContext)+","+formatString(idFitxa)+","+formatString(idDiccionari)+","+formatString(idLlengua)+","+formatString(contextNormal)+","+formatString(contextRtf)+")";
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new CreateException("Error inserting row");
  } catch (Exception e) {
    throw new CreateException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Inserts to the database for table "co_context"
  */
public void create() throws CreateException {
  Connection con = null;
  Statement stm = null;
  try {
    String sql="INSERT INTO co_context (ID_CONTEXT,ID_FITXA,ID_DICCIONARI,ID_LLENGUA,CONTEXT_NORMAL,CONTEXT_RTF) VALUES ("+formatString(idContext)+","+formatString(idFitxa)+","+formatString(idDiccionari)+","+formatString(idLlengua)+","+formatString(contextNormal)+","+formatString(contextRtf)+")";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new CreateException("Error inserting row");
  } catch (Exception e) {
    throw new CreateException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Updates the current object values into the database.
  */
protected void store(Connection con) throws StoreException {
  if (!dirty)
    return;
  if (!isGlobalDirty())
    return;
  Statement stm = null;
  try {
    String sql="UPDATE co_context set ";
    int idx = 0;
    if (dirtyFields[idx++]) {
      sql+="ID_CONTEXT="+formatString(idContext)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_FITXA="+formatString(idFitxa)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_DICCIONARI="+formatString(idDiccionari)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_LLENGUA="+formatString(idLlengua)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="CONTEXT_NORMAL="+formatString(contextNormal)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="CONTEXT_RTF="+formatString(contextRtf)+",";
    }
    sql=sql.substring(0,sql.length()-1);
    sql=sql+" where ID_CONTEXT="+formatString(idContext);
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1) {
      throw new StoreException("Error updating row");
    }
    dirty = false;
    valid = true;
    dirtyFields = dirtyFieldsDefault;
  } catch (Exception e) {
  throw new StoreException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Updates the current object values into the database.
  */
protected void store() throws StoreException {
  if (!dirty)
    return;
  if (!isGlobalDirty())
    return;
  Connection con = null;
  Statement stm = null;
  try {
    String sql="UPDATE co_context set ";
    int idx = 0;
    if (dirtyFields[idx++]) {
      sql+="ID_CONTEXT="+formatString(idContext)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_FITXA="+formatString(idFitxa)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_DICCIONARI="+formatString(idDiccionari)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_LLENGUA="+formatString(idLlengua)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="CONTEXT_NORMAL="+formatString(contextNormal)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="CONTEXT_RTF="+formatString(contextRtf)+",";
    }
    sql=sql.substring(0,sql.length()-1);
    sql=sql+" where ID_CONTEXT="+formatString(idContext);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1) {
      throw new StoreException("Error updating row");
    }
    dirty = false;
    valid = true;
    dirtyFields = dirtyFieldsDefault;
  } catch (Exception e) {
  throw new StoreException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Deletes from the database for table "co_context"
  */
public void remove(Connection con) throws RemoveException {
  Statement stm = null;
  try {
    String sql="DELETE FROM co_context WHERE ID_CONTEXT="+formatString(idContext);
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new RemoveException("Error deleting row");
  } catch (Exception e) {
    throw new RemoveException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Deletes from the database for table "co_context"
  */
public void remove() throws RemoveException {
  Connection con = null;
  Statement stm = null;
  try {
    String sql="DELETE FROM co_context WHERE ID_CONTEXT="+formatString(idContext);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new RemoveException("Error deleting row");
  } catch (Exception e) {
    throw new RemoveException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

public int compareTo(Object o) {
  ContextSkel cn = (ContextSkel) o;
  int result = 0;
  result = this.idContext.compareTo(cn.idContext);
  if (result != 0) { return result; };
  result = this.idFitxa.compareTo(cn.idFitxa);
  if (result != 0) { return result; };
  result = this.idDiccionari.compareTo(cn.idDiccionari);
  if (result != 0) { return result; };
  result = this.idLlengua.compareTo(cn.idLlengua);
  if (result != 0) { return result; };
  result = this.contextNormal.compareTo(cn.contextNormal);
  if (result != 0) { return result; };
  result = this.contextRtf.compareTo(cn.contextRtf);
  if (result != 0) { return result; };
  return result;
}
/**
  * Finds and return the object of this PK.
  */
public ContextSkel findByPrimaryKey(String idContext) throws FinderException {
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  try {
    String sql="SELECT * FROM CO_CONTEXT" +" where ID_CONTEXT="+formatString(idContext);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    if (!rs.next()) {
      throw new FinderException("Primary Key not found");
    }
    this.idContext = rs.getString("ID_CONTEXT");
    this.idFitxa = rs.getString("ID_FITXA");
    this.idDiccionari = rs.getString("ID_DICCIONARI");
    this.idLlengua = rs.getString("ID_LLENGUA");
    this.contextNormal = rs.getString("CONTEXT_NORMAL");
    this.contextRtf = rs.getString("CONTEXT_RTF");
    return this;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Finds and return a List for a generic where.
  */
public List findByGenericWhere(String where) throws FinderException {
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  List result = new ArrayList();
  try {
    String sql="SELECT * FROM CO_CONTEXT" +" WHERE "+where;
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    while (rs.next()) {
      ContextSkel tmp = (ContextSkel) this.getClass().newInstance();
      tmp.idContext = rs.getString("ID_CONTEXT");
      tmp.idFitxa = rs.getString("ID_FITXA");
      tmp.idDiccionari = rs.getString("ID_DICCIONARI");
      tmp.idLlengua = rs.getString("ID_LLENGUA");
      tmp.contextNormal = rs.getString("CONTEXT_NORMAL");
      tmp.contextRtf = rs.getString("CONTEXT_RTF");
      result.add(tmp);
    }
    return result;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

  protected void load() throws LoadException {
  if (valid)
    return;
  try {
    ContextSkel cn = findByPrimaryKey(idContext);
  cn.setValid(true);
    this.idContext = cn.getIdContext();
    this.idFitxa = cn.getIdFitxa();
    this.idDiccionari = cn.getIdDiccionari();
    this.idLlengua = cn.getIdLlengua();
    this.contextNormal = cn.getContextNormal();
    this.contextRtf = cn.getContextRtf();
    dirty = false;
    valid = true;
  } catch (FinderException e) {
     throw new LoadException(e.toString());
  }
}

/**
  * Synchronize the current object values into the database.
  */
public void flush() throws Exception{
  try {
    if (dirty) {
      store();
      dirty = false;
    }
  } catch (Exception e) {
    e.printStackTrace();
  throw e;
  }
}
/**
  * Synchronize the current object values into the database.
  */
public void flush(Connection con) throws Exception{
  try {
    if (dirty) {
      store(con);
      dirty = false;
    }
  } catch (Exception e) {
    e.printStackTrace();
  throw e;
  }
}

  public static String formatString(String st) {
    String stString = "null";
    if (st != null) {
      if (st.indexOf("'") != -1)
        st = BdUtils.replaceString(st,"'","''");
      stString = "'"+st+"'";
    }
    return stString;
  }

  public static String formatTimeStamp(Timestamp ts)  {
    String tsString = "null";
    if (ts!=null) {
        tsString = "'"+ts.toString()+"'";
    }
    return tsString;
  }

  public static String formatInteger(int i) {
    if (i == NULL_INT)
      return "NULL";
    else
      return ""+i;
  }

  public static String formatDouble(double d) {
    if (d == NULL_DOUBLE)
      return "NULL";
    else
      return ""+d;
  }

  public static String formatLong(long l) {
    if (l == NULL_LONG)
      return "NULL";
    else
      return ""+l;
  }

  public static String formatShort(double s) {
    if (s == NULL_SHORT)
      return "NULL";
    else
      return ""+s;
  }

  public static String formatFloat(float f) {
    if (f == NULL_FLOAT)
      return "NULL";
    else
      return ""+f;
  }

  public static String formatDate(java.util.Date d)  {
    String tsString = "null";
    if (d!=null) {
        tsString = "'"+d.toString()+"'";
    }
    return tsString;
  }

  public String toString() {
    String result = "\n";
    result+="idContext: "+idContext+"\n";
    result+="idFitxa: "+idFitxa+"\n";
    result+="idDiccionari: "+idDiccionari+"\n";
    result+="idLlengua: "+idLlengua+"\n";
    result+="contextNormal: "+contextNormal+"\n";
    result+="contextRtf: "+contextRtf+"\n";
    return result;
  }


  public Element toXml() {
    Document doc = new Document();
    Element main = doc.addElement("Context");
    Element elem_1= doc.addElement("idContext");
    elem_1.setText(""+(this.getIdContext() == null || this.getIdContext().equals("null")?"":this.getIdContext()));
    main.addChild(elem_1);
    Element elem_2= doc.addElement("idFitxa");
    elem_2.setText(""+(this.getIdFitxa() == null || this.getIdFitxa().equals("null")?"":this.getIdFitxa()));
    main.addChild(elem_2);
    Element elem_3= doc.addElement("idDiccionari");
    elem_3.setText(""+(this.getIdDiccionari() == null || this.getIdDiccionari().equals("null")?"":this.getIdDiccionari()));
    main.addChild(elem_3);
    Element elem_4= doc.addElement("idLlengua");
    elem_4.setText(""+(this.getIdLlengua() == null || this.getIdLlengua().equals("null")?"":this.getIdLlengua()));
    main.addChild(elem_4);
    Element elem_5= doc.addElement("contextNormal");
    elem_5.setText(""+(this.getContextNormal() == null || this.getContextNormal().equals("null")?"":this.getContextNormal()));
    main.addChild(elem_5);
    Element elem_6= doc.addElement("contextRtf");
    elem_6.setText(""+(this.getContextRtf() == null || this.getContextRtf().equals("null")?"":this.getContextRtf()));
    main.addChild(elem_6);
    doc.addChild(main);
    return doc.getRoot();

  }


  public boolean isDirty() {
    return this.dirty;
  }

  public boolean isValid() {
    return this.valid;
  }

  public void setDirty(boolean dirty) {
    this.dirty = dirty;
    if (this.dirty == false) dirtyFields = dirtyFieldsDefault;
  }

  public void setValid(boolean valid) {
    this.valid = valid;
  }
  public boolean isGlobalDirty(){
  boolean result = false;
  for (int i=0;i<numFields;i++)
    result=result || dirtyFields[i];
  return result;
  }

public Vector findAll() throws FinderException { 
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  Vector v = new Vector();
  try {
    String sql="SELECT * from co_context ";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    while (rs.next()) {
      ContextSkel tmp=(ContextSkel) this.getClass().newInstance();
      tmp.idContext = rs.getString("ID_CONTEXT");
      tmp.idFitxa = rs.getString("ID_FITXA");
      tmp.idDiccionari = rs.getString("ID_DICCIONARI");
      tmp.idLlengua = rs.getString("ID_LLENGUA");
      tmp.contextNormal = rs.getString("CONTEXT_NORMAL");
      tmp.contextRtf = rs.getString("CONTEXT_RTF");
      v.add(tmp);
    }
    return v;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}


public Element findAllXml() { 
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  int k=0;
  try {
    String sql="SELECT * from co_context ";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    Element queryResult = new Element("query-result");
    while (rs.next()) {
      ContextSkel tmp=new ContextSkel();
      tmp.idContext = rs.getString("ID_CONTEXT");
      tmp.idFitxa = rs.getString("ID_FITXA");
      tmp.idDiccionari = rs.getString("ID_DICCIONARI");
      tmp.idLlengua = rs.getString("ID_LLENGUA");
      tmp.contextNormal = rs.getString("CONTEXT_NORMAL");
      tmp.contextRtf = rs.getString("CONTEXT_RTF");
      Element tmpElem = tmp.toXml();
      tmpElem.setAttribute("rowid",""+k);
      queryResult.addChild(tmpElem);
      k++;
    }
    return queryResult;
  } catch (Exception e) {
    throw new BaseRuntimeException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}


}
