//Generation Date: Wed Nov 21 15:53:28 CET 2007
package com.termcat.bd.beans.skels;

import java.sql.*;
import java.io.*;
import java.util.Vector;
import java.util.List;
import com.termcat.bd.utils.DBConnect;
import com.termcat.bd.exceptions.*;
import electric.xml.*;

import java.util.*;
import java.text.*;

/**
  * DenominacionsSkel
  * Clase para acceder a BD
  * DBTable: co_denominacions
  * @author collazos
  * -----------------------------------------
  * Database version : 1.0 (2007-04-29)
  * Driver Name : H2 JDBC Driver
  * Driver Version : 1.0
  * Generator version : 2.2.0
  * Generation Date : Wed Nov 21 15:53:28 CET 2007
  * @todo extends this class always !!!
  * 
  */
public class DenominacionsSkel implements Serializable, Comparable {
  public final static String TABLE_NAME = "co_denominacions"; // (Alias from: co_denominacions)
  private boolean dirty = false;
  private boolean valid = true;
  public static int numFields = 9;

  /**
   * Random Generated UID for this serializable class
   * <code>serialVersionUID</code>
   */
  private static final long serialVersionUID =-7881649279494181949L;

  public static final long NULL_LONG =9223372036854775807L;
  public static final double NULL_DOUBLE =1.7976931348623157E308;
  public static final int NULL_INT =2147483647;
  public static final short NULL_SHORT =32767;
  public static final float NULL_FLOAT =3.4028235E38f;

  /**
   * Dirty flags for all fields
   */
 private boolean[] dirtyFields = {false,false,false,false,false,false,false,false,false};
 private final boolean[] dirtyFieldsDefault = {false,false,false,false,false,false,false,false,false};

  public DenominacionsSkel(String idDenominacio,String idDiccionari,String idLlengua,String idMarca,String idJerarquia,String idCategoria,String idFitxa,String termeRtf,String termeNormal) {
    this.idDenominacio = idDenominacio;
    this.idDiccionari = idDiccionari;
    this.idLlengua = idLlengua;
    this.idMarca = idMarca;
    this.idJerarquia = idJerarquia;
    this.idCategoria = idCategoria;
    this.idFitxa = idFitxa;
    this.termeRtf = termeRtf;
    this.termeNormal = termeNormal;
  }

  public DenominacionsSkel(String idDenominacio) {
    this.idDenominacio = idDenominacio;
  }

  public DenominacionsSkel() { 
  }

  /**
    * Type : VARCHAR Name : ID_DENOMINACIO
    */
    private String idDenominacio;

  /**
    * Type : VARCHAR Name : ID_DICCIONARI
    */
    private String idDiccionari;

  /**
    * Type : VARCHAR Name : ID_LLENGUA
    */
    private String idLlengua;

  /**
    * Type : VARCHAR Name : ID_MARCA
    */
    private String idMarca;

  /**
    * Type : VARCHAR Name : ID_JERARQUIA
    */
    private String idJerarquia;

  /**
    * Type : VARCHAR Name : ID_CATEGORIA
    */
    private String idCategoria;

  /**
    * Type : VARCHAR Name : ID_FITXA
    */
    private String idFitxa;

  /**
    * Type : VARCHAR Name : TERME_RTF
    */
    private String termeRtf;

  /**
    * Type : VARCHAR Name : TERME_NORMAL
    */
    private String termeNormal;

  /**
    * Sets the value for idDenominacio
    * @param idDenominacio
    */
  public void setIdDenominacio(String idDenominacio) {
    if (idDenominacio.length() > 64)
      this.idDenominacio=idDenominacio.substring(0,64);
    else this.idDenominacio=idDenominacio;
    this.dirty = true;
    dirtyFields[0] = true;
  }

  /**
    * Gets the value for idDenominacio
    */
  public String getIdDenominacio() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idDenominacio;
  }

  /**
    * Sets the value for idDiccionari
    * @param idDiccionari
    */
  public void setIdDiccionari(String idDiccionari) {
    if (idDiccionari.length() > 64)
      this.idDiccionari=idDiccionari.substring(0,64);
    else this.idDiccionari=idDiccionari;
    this.dirty = true;
    dirtyFields[1] = true;
  }

  /**
    * Gets the value for idDiccionari
    */
  public String getIdDiccionari() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idDiccionari;
  }

  /**
    * Sets the value for idLlengua
    * @param idLlengua
    */
  public void setIdLlengua(String idLlengua) {
    if (idLlengua.length() > 64)
      this.idLlengua=idLlengua.substring(0,64);
    else this.idLlengua=idLlengua;
    this.dirty = true;
    dirtyFields[2] = true;
  }

  /**
    * Gets the value for idLlengua
    */
  public String getIdLlengua() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idLlengua;
  }

  /**
    * Sets the value for idMarca
    * @param idMarca
    */
  public void setIdMarca(String idMarca) {
    if (idMarca.length() > 64)
      this.idMarca=idMarca.substring(0,64);
    else this.idMarca=idMarca;
    this.dirty = true;
    dirtyFields[3] = true;
  }

  /**
    * Gets the value for idMarca
    */
  public String getIdMarca() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idMarca;
  }

  /**
    * Sets the value for idJerarquia
    * @param idJerarquia
    */
  public void setIdJerarquia(String idJerarquia) {
    if (idJerarquia.length() > 64)
      this.idJerarquia=idJerarquia.substring(0,64);
    else this.idJerarquia=idJerarquia;
    this.dirty = true;
    dirtyFields[4] = true;
  }

  /**
    * Gets the value for idJerarquia
    */
  public String getIdJerarquia() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idJerarquia;
  }

  /**
    * Sets the value for idCategoria
    * @param idCategoria
    */
  public void setIdCategoria(String idCategoria) {
    if (idCategoria.length() > 64)
      this.idCategoria=idCategoria.substring(0,64);
    else this.idCategoria=idCategoria;
    this.dirty = true;
    dirtyFields[5] = true;
  }

  /**
    * Gets the value for idCategoria
    */
  public String getIdCategoria() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idCategoria;
  }

  /**
    * Sets the value for idFitxa
    * @param idFitxa
    */
  public void setIdFitxa(String idFitxa) {
    if (idFitxa.length() > 64)
      this.idFitxa=idFitxa.substring(0,64);
    else this.idFitxa=idFitxa;
    this.dirty = true;
    dirtyFields[6] = true;
  }

  /**
    * Gets the value for idFitxa
    */
  public String getIdFitxa() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idFitxa;
  }

  /**
    * Sets the value for termeRtf
    * @param termeRtf
    */
  public void setTermeRtf(String termeRtf) {
    if (termeRtf.length() > 18000)
      this.termeRtf=termeRtf.substring(0,18000);
    else this.termeRtf=termeRtf;
    this.dirty = true;
    dirtyFields[7] = true;
  }

  /**
    * Gets the value for termeRtf
    */
  public String getTermeRtf() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return termeRtf;
  }

  /**
    * Sets the value for termeNormal
    * @param termeNormal
    */
  public void setTermeNormal(String termeNormal) {
    if (termeNormal.length() > 9000)
      this.termeNormal=termeNormal.substring(0,9000);
    else this.termeNormal=termeNormal;
    this.dirty = true;
    dirtyFields[8] = true;
  }

  /**
    * Gets the value for termeNormal
    */
  public String getTermeNormal() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return termeNormal;
  }

/**
  * Return a boolean if the element with PK exists.
  */
public boolean exists(String idDenominacio)  {
  boolean exists = false;
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  try {
    String sql="SELECT * FROM CO_DENOMINACIONS" +" where ID_DENOMINACIO="+formatString(idDenominacio);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    if (rs.next()) {
      exists = true;
    }
  } catch (Exception e) {
    exists = false;
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
  return exists;
}

/**
  * Inserts to the database for table "co_denominacions"
  */
public void create(Connection con) throws CreateException {
  Statement stm = null;
  try {
    String sql="INSERT INTO co_denominacions (ID_DENOMINACIO,ID_DICCIONARI,ID_LLENGUA,ID_MARCA,ID_JERARQUIA,ID_CATEGORIA,ID_FITXA,TERME_RTF,TERME_NORMAL) VALUES ("+formatString(idDenominacio)+","+formatString(idDiccionari)+","+formatString(idLlengua)+","+formatString(idMarca)+","+formatString(idJerarquia)+","+formatString(idCategoria)+","+formatString(idFitxa)+","+formatString(termeRtf)+","+formatString(termeNormal)+")";
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new CreateException("Error inserting row");
  } catch (Exception e) {
    throw new CreateException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Inserts to the database for table "co_denominacions"
  */
public void create() throws CreateException {
  Connection con = null;
  Statement stm = null;
  try {
    String sql="INSERT INTO co_denominacions (ID_DENOMINACIO,ID_DICCIONARI,ID_LLENGUA,ID_MARCA,ID_JERARQUIA,ID_CATEGORIA,ID_FITXA,TERME_RTF,TERME_NORMAL) VALUES ("+formatString(idDenominacio)+","+formatString(idDiccionari)+","+formatString(idLlengua)+","+formatString(idMarca)+","+formatString(idJerarquia)+","+formatString(idCategoria)+","+formatString(idFitxa)+","+formatString(termeRtf)+","+formatString(termeNormal)+")";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new CreateException("Error inserting row");
  } catch (Exception e) {
    throw new CreateException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Updates the current object values into the database.
  */
protected void store(Connection con) throws StoreException {
  if (!dirty)
    return;
  if (!isGlobalDirty())
    return;
  Statement stm = null;
  try {
    String sql="UPDATE co_denominacions set ";
    int idx = 0;
    if (dirtyFields[idx++]) {
      sql+="ID_DENOMINACIO="+formatString(idDenominacio)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_DICCIONARI="+formatString(idDiccionari)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_LLENGUA="+formatString(idLlengua)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_MARCA="+formatString(idMarca)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_JERARQUIA="+formatString(idJerarquia)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_CATEGORIA="+formatString(idCategoria)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_FITXA="+formatString(idFitxa)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="TERME_RTF="+formatString(termeRtf)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="TERME_NORMAL="+formatString(termeNormal)+",";
    }
    sql=sql.substring(0,sql.length()-1);
    sql=sql+" where ID_DENOMINACIO="+formatString(idDenominacio);
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1) {
      throw new StoreException("Error updating row");
    }
    dirty = false;
    valid = true;
    dirtyFields = dirtyFieldsDefault;
  } catch (Exception e) {
  throw new StoreException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Updates the current object values into the database.
  */
protected void store() throws StoreException {
  if (!dirty)
    return;
  if (!isGlobalDirty())
    return;
  Connection con = null;
  Statement stm = null;
  try {
    String sql="UPDATE co_denominacions set ";
    int idx = 0;
    if (dirtyFields[idx++]) {
      sql+="ID_DENOMINACIO="+formatString(idDenominacio)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_DICCIONARI="+formatString(idDiccionari)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_LLENGUA="+formatString(idLlengua)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_MARCA="+formatString(idMarca)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_JERARQUIA="+formatString(idJerarquia)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_CATEGORIA="+formatString(idCategoria)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_FITXA="+formatString(idFitxa)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="TERME_RTF="+formatString(termeRtf)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="TERME_NORMAL="+formatString(termeNormal)+",";
    }
    sql=sql.substring(0,sql.length()-1);
    sql=sql+" where ID_DENOMINACIO="+formatString(idDenominacio);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1) {
      throw new StoreException("Error updating row");
    }
    dirty = false;
    valid = true;
    dirtyFields = dirtyFieldsDefault;
  } catch (Exception e) {
  throw new StoreException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Deletes from the database for table "co_denominacions"
  */
public void remove(Connection con) throws RemoveException {
  Statement stm = null;
  try {
    String sql="DELETE FROM co_denominacions WHERE ID_DENOMINACIO="+formatString(idDenominacio);
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new RemoveException("Error deleting row");
  } catch (Exception e) {
    throw new RemoveException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Deletes from the database for table "co_denominacions"
  */
public void remove() throws RemoveException {
  Connection con = null;
  Statement stm = null;
  try {
    String sql="DELETE FROM co_denominacions WHERE ID_DENOMINACIO="+formatString(idDenominacio);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new RemoveException("Error deleting row");
  } catch (Exception e) {
    throw new RemoveException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

public int compareTo(Object o) {
  DenominacionsSkel cn = (DenominacionsSkel) o;
  int result = 0;
  result = this.idDenominacio.compareTo(cn.idDenominacio);
  if (result != 0) { return result; };
  result = this.idDiccionari.compareTo(cn.idDiccionari);
  if (result != 0) { return result; };
  result = this.idLlengua.compareTo(cn.idLlengua);
  if (result != 0) { return result; };
  result = this.idMarca.compareTo(cn.idMarca);
  if (result != 0) { return result; };
  result = this.idJerarquia.compareTo(cn.idJerarquia);
  if (result != 0) { return result; };
  result = this.idCategoria.compareTo(cn.idCategoria);
  if (result != 0) { return result; };
  result = this.idFitxa.compareTo(cn.idFitxa);
  if (result != 0) { return result; };
  result = this.termeRtf.compareTo(cn.termeRtf);
  if (result != 0) { return result; };
  result = this.termeNormal.compareTo(cn.termeNormal);
  if (result != 0) { return result; };
  return result;
}
/**
  * Finds and return the object of this PK.
  */
public DenominacionsSkel findByPrimaryKey(String idDenominacio) throws FinderException {
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  try {
    String sql="SELECT * FROM CO_DENOMINACIONS" +" where ID_DENOMINACIO="+formatString(idDenominacio);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    if (!rs.next()) {
      throw new FinderException("Primary Key not found");
    }
    this.idDenominacio = rs.getString("ID_DENOMINACIO");
    this.idDiccionari = rs.getString("ID_DICCIONARI");
    this.idLlengua = rs.getString("ID_LLENGUA");
    this.idMarca = rs.getString("ID_MARCA");
    this.idJerarquia = rs.getString("ID_JERARQUIA");
    this.idCategoria = rs.getString("ID_CATEGORIA");
    this.idFitxa = rs.getString("ID_FITXA");
    this.termeRtf = rs.getString("TERME_RTF");
    this.termeNormal = rs.getString("TERME_NORMAL");
    return this;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Finds and return a List for a generic where.
  */
public List findByGenericWhere(String where) throws FinderException {
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  List result = new ArrayList();
  try {
    String sql="SELECT * FROM CO_DENOMINACIONS" +" WHERE "+where;
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    while (rs.next()) {
      DenominacionsSkel tmp = (DenominacionsSkel) this.getClass().newInstance();
      tmp.idDenominacio = rs.getString("ID_DENOMINACIO");
      tmp.idDiccionari = rs.getString("ID_DICCIONARI");
      tmp.idLlengua = rs.getString("ID_LLENGUA");
      tmp.idMarca = rs.getString("ID_MARCA");
      tmp.idJerarquia = rs.getString("ID_JERARQUIA");
      tmp.idCategoria = rs.getString("ID_CATEGORIA");
      tmp.idFitxa = rs.getString("ID_FITXA");
      tmp.termeRtf = rs.getString("TERME_RTF");
      tmp.termeNormal = rs.getString("TERME_NORMAL");
      result.add(tmp);
    }
    return result;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

  protected void load() throws LoadException {
  if (valid)
    return;
  try {
    DenominacionsSkel cn = findByPrimaryKey(idDenominacio);
  cn.setValid(true);
    this.idDenominacio = cn.getIdDenominacio();
    this.idDiccionari = cn.getIdDiccionari();
    this.idLlengua = cn.getIdLlengua();
    this.idMarca = cn.getIdMarca();
    this.idJerarquia = cn.getIdJerarquia();
    this.idCategoria = cn.getIdCategoria();
    this.idFitxa = cn.getIdFitxa();
    this.termeRtf = cn.getTermeRtf();
    this.termeNormal = cn.getTermeNormal();
    dirty = false;
    valid = true;
  } catch (FinderException e) {
     throw new LoadException(e.toString());
  }
}

/**
  * Synchronize the current object values into the database.
  */
public void flush() throws Exception{
  try {
    if (dirty) {
      store();
      dirty = false;
    }
  } catch (Exception e) {
    e.printStackTrace();
  throw e;
  }
}
/**
  * Synchronize the current object values into the database.
  */
public void flush(Connection con) throws Exception{
  try {
    if (dirty) {
      store(con);
      dirty = false;
    }
  } catch (Exception e) {
    e.printStackTrace();
  throw e;
  }
}

  public static String formatString(String st) {
    String stString = "null";
    if (st != null) {
      if (st.indexOf("'") != -1)
        st = BdUtils.replaceString(st,"'","''");
      stString = "'"+st+"'";
    }
    return stString;
  }

  public static String formatTimeStamp(Timestamp ts)  {
    String tsString = "null";
    if (ts!=null) {
        tsString = "'"+ts.toString()+"'";
    }
    return tsString;
  }

  public static String formatInteger(int i) {
    if (i == NULL_INT)
      return "NULL";
    else
      return ""+i;
  }

  public static String formatDouble(double d) {
    if (d == NULL_DOUBLE)
      return "NULL";
    else
      return ""+d;
  }

  public static String formatLong(long l) {
    if (l == NULL_LONG)
      return "NULL";
    else
      return ""+l;
  }

  public static String formatShort(double s) {
    if (s == NULL_SHORT)
      return "NULL";
    else
      return ""+s;
  }

  public static String formatFloat(float f) {
    if (f == NULL_FLOAT)
      return "NULL";
    else
      return ""+f;
  }

  public static String formatDate(java.util.Date d)  {
    String tsString = "null";
    if (d!=null) {
        tsString = "'"+d.toString()+"'";
    }
    return tsString;
  }

  public String toString() {
    String result = "\n";
    result+="idDenominacio: "+idDenominacio+"\n";
    result+="idDiccionari: "+idDiccionari+"\n";
    result+="idLlengua: "+idLlengua+"\n";
    result+="idMarca: "+idMarca+"\n";
    result+="idJerarquia: "+idJerarquia+"\n";
    result+="idCategoria: "+idCategoria+"\n";
    result+="idFitxa: "+idFitxa+"\n";
    result+="termeRtf: "+termeRtf+"\n";
    result+="termeNormal: "+termeNormal+"\n";
    return result;
  }


  public Element toXml() {
    Document doc = new Document();
    Element main = doc.addElement("Denominacions");
    Element elem_1= doc.addElement("idDenominacio");
    elem_1.setText(""+(this.getIdDenominacio() == null || this.getIdDenominacio().equals("null")?"":this.getIdDenominacio()));
    main.addChild(elem_1);
    Element elem_2= doc.addElement("idDiccionari");
    elem_2.setText(""+(this.getIdDiccionari() == null || this.getIdDiccionari().equals("null")?"":this.getIdDiccionari()));
    main.addChild(elem_2);
    Element elem_3= doc.addElement("idLlengua");
    elem_3.setText(""+(this.getIdLlengua() == null || this.getIdLlengua().equals("null")?"":this.getIdLlengua()));
    main.addChild(elem_3);
    Element elem_4= doc.addElement("idMarca");
    elem_4.setText(""+(this.getIdMarca() == null || this.getIdMarca().equals("null")?"":this.getIdMarca()));
    main.addChild(elem_4);
    Element elem_5= doc.addElement("idJerarquia");
    elem_5.setText(""+(this.getIdJerarquia() == null || this.getIdJerarquia().equals("null")?"":this.getIdJerarquia()));
    main.addChild(elem_5);
    Element elem_6= doc.addElement("idCategoria");
    elem_6.setText(""+(this.getIdCategoria() == null || this.getIdCategoria().equals("null")?"":this.getIdCategoria()));
    main.addChild(elem_6);
    Element elem_7= doc.addElement("idFitxa");
    elem_7.setText(""+(this.getIdFitxa() == null || this.getIdFitxa().equals("null")?"":this.getIdFitxa()));
    main.addChild(elem_7);
    Element elem_8= doc.addElement("termeRtf");
    elem_8.setText(""+(this.getTermeRtf() == null || this.getTermeRtf().equals("null")?"":this.getTermeRtf()));
    main.addChild(elem_8);
    Element elem_9= doc.addElement("termeNormal");
    elem_9.setText(""+(this.getTermeNormal() == null || this.getTermeNormal().equals("null")?"":this.getTermeNormal()));
    main.addChild(elem_9);
    doc.addChild(main);
    return doc.getRoot();

  }


  public boolean isDirty() {
    return this.dirty;
  }

  public boolean isValid() {
    return this.valid;
  }

  public void setDirty(boolean dirty) {
    this.dirty = dirty;
    if (this.dirty == false) dirtyFields = dirtyFieldsDefault;
  }

  public void setValid(boolean valid) {
    this.valid = valid;
  }
  public boolean isGlobalDirty(){
  boolean result = false;
  for (int i=0;i<numFields;i++)
    result=result || dirtyFields[i];
  return result;
  }

public Vector findAll() throws FinderException { 
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  Vector v = new Vector();
  try {
    String sql="SELECT * from co_denominacions ";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    while (rs.next()) {
      DenominacionsSkel tmp=(DenominacionsSkel) this.getClass().newInstance();
      tmp.idDenominacio = rs.getString("ID_DENOMINACIO");
      tmp.idDiccionari = rs.getString("ID_DICCIONARI");
      tmp.idLlengua = rs.getString("ID_LLENGUA");
      tmp.idMarca = rs.getString("ID_MARCA");
      tmp.idJerarquia = rs.getString("ID_JERARQUIA");
      tmp.idCategoria = rs.getString("ID_CATEGORIA");
      tmp.idFitxa = rs.getString("ID_FITXA");
      tmp.termeRtf = rs.getString("TERME_RTF");
      tmp.termeNormal = rs.getString("TERME_NORMAL");
      v.add(tmp);
    }
    return v;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}


public Element findAllXml() { 
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  int k=0;
  try {
    String sql="SELECT * from co_denominacions ";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    Element queryResult = new Element("query-result");
    while (rs.next()) {
      DenominacionsSkel tmp=new DenominacionsSkel();
      tmp.idDenominacio = rs.getString("ID_DENOMINACIO");
      tmp.idDiccionari = rs.getString("ID_DICCIONARI");
      tmp.idLlengua = rs.getString("ID_LLENGUA");
      tmp.idMarca = rs.getString("ID_MARCA");
      tmp.idJerarquia = rs.getString("ID_JERARQUIA");
      tmp.idCategoria = rs.getString("ID_CATEGORIA");
      tmp.idFitxa = rs.getString("ID_FITXA");
      tmp.termeRtf = rs.getString("TERME_RTF");
      tmp.termeNormal = rs.getString("TERME_NORMAL");
      Element tmpElem = tmp.toXml();
      tmpElem.setAttribute("rowid",""+k);
      queryResult.addChild(tmpElem);
      k++;
    }
    return queryResult;
  } catch (Exception e) {
    throw new BaseRuntimeException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}


}
