/*
 * TransferableNode.java
 *
 * Created on 12 de septiembre de 2007, 11:02
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.layout.commons.dndtree;

/**
 *
 * @author mena
 */
    
  import java.awt.datatransfer.*;
import javax.swing.tree.*;
import java.util.*;
 
public class TransferableNode implements Transferable {
	public static final DataFlavor NODE_FLAVOR = new DataFlavor(DataFlavor.javaJVMLocalObjectMimeType, java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("NodeLabel"));
	private DefaultMutableTreeNode node;
	private DataFlavor[] flavors = { NODE_FLAVOR };
 
	public TransferableNode(DefaultMutableTreeNode nd) {
		node = nd;
	}  
 
	public synchronized Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException {
		if (flavor == NODE_FLAVOR) {
			return node;
		}
		else {
			throw new UnsupportedFlavorException(flavor);	
		}			
	}
 
	public DataFlavor[] getTransferDataFlavors() {
		return flavors;
	}
 
	public boolean isDataFlavorSupported(DataFlavor flavor) {
		return Arrays.asList(flavors).contains(flavor);
	}
}


