/*
 * AreesMainThread.java
 *
 * Created on 29 de enero de 2008, 14:55
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.layout.terminologic.fitxes;

import com.termcat.bd.beans.AreesFitxes;
import com.termcat.bd.beans.Definicions;
import com.termcat.bd.beans.Denominacions;
import com.termcat.bd.beans.Fitxes;
import com.termcat.bd.beans.Notes;
import com.termcat.bd.exceptions.FinderException;
import com.termcat.business.exceptions.DataException;
import com.termcat.business.reports.llistat.BeanFichaData;
import com.termcat.business.terminologic.search.SearchManager;
import com.termcat.layout.MainFrame;
import com.termcat.layout.commons.ItemCustom;
import com.termcat.layout.commons.fitxes.FitxesManager;
import com.termcat.layout.commons.popup.MousePopupListener;
import com.termcat.layout.commons.popup.PopupMenuTable;
import com.termcat.layout.commons.search.Search;
import java.util.ArrayList;
import java.util.List;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JTable;
import javax.swing.JTree;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author Mena
 */
public class FitxesMainThread extends Thread
{    
    private MainFrame menuFrame;    
    private JDialog loader;
    private FitxesMain fMain;    
       
    /** Creates a new instance of AreesMainThread */
    public FitxesMainThread(MainFrame menuFrame,JDialog dialog,FitxesMain fMain) 
    {
        super();
        this.menuFrame=menuFrame;              
        this.loader=dialog;
        this.fMain=fMain;
    }
    
    public void run() 
    {    
        try 
        {  
            new FitxesManager().refreshContents(this.menuFrame,this.fMain);            
        }
        catch (Exception ex) 
        {
            ex.printStackTrace();            
            this.menuFrame.showMessageError(ex.getMessage());
        }    
        finally
        {
            loader.setVisible(false);                    
            this.interrupt();            
        }
    }        
}
