/*
 * BDUtils.java
 *
 * Created on 10 de octubre de 2007, 8:20
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.bd.beans;

import com.termcat.bd.exceptions.BaseRuntimeException;
import com.termcat.bd.utils.DBConnect;
import java.sql.Connection;
import java.sql.Statement;

/**
 *
 * @author mena
 */
public class BDUtil extends com.termcat.bd.beans.skels.BdUtils
{
    
    /** Creates a new instance of BDUtils */
    public BDUtil() {
    }
    
   public static boolean execute(String sql) throws Exception
  {
        Connection con = null;
        Statement stm = null;
        boolean ok = false;
        try {
          con = DBConnect.getConnection();
          stm = con.createStatement();
          ok = stm.execute(sql);
          return ok;
        }
        catch (Exception e) 
        {
          throw new BaseRuntimeException(e.toString());
        } 
        finally 
        {
          if (stm != null) try { stm.close(); } catch (Exception ignored) {}
          if (con != null) DBConnect.putConnection(con);
        }
   }
}
