//Generation Date: Wed Nov 21 15:53:27 CET 2007
package com.termcat.bd.beans.skels;

import java.sql.*;
import java.io.*;
import java.util.Vector;
import java.util.List;
import com.termcat.bd.utils.DBConnect;
import com.termcat.bd.exceptions.*;
import electric.xml.*;

import java.util.*;
import java.text.*;

/**
  * ArbreCampSkel
  * Clase para acceder a BD
  * DBTable: co_arbre_camp
  * @author collazos
  * -----------------------------------------
  * Database version : 1.0 (2007-04-29)
  * Driver Name : H2 JDBC Driver
  * Driver Version : 1.0
  * Generator version : 2.2.0
  * Generation Date : Wed Nov 21 15:53:27 CET 2007
  * @todo extends this class always !!!
  * 
  */
public class ArbreCampSkel implements Serializable, Comparable {
  public final static String TABLE_NAME = "co_arbre_camp"; // (Alias from: co_arbre_camp)
  private boolean dirty = false;
  private boolean valid = true;
  public static int numFields = 4;

  /**
   * Random Generated UID for this serializable class
   * <code>serialVersionUID</code>
   */
  private static final long serialVersionUID =4187716595236147582L;

  public static final long NULL_LONG =9223372036854775807L;
  public static final double NULL_DOUBLE =1.7976931348623157E308;
  public static final int NULL_INT =2147483647;
  public static final short NULL_SHORT =32767;
  public static final float NULL_FLOAT =3.4028235E38f;

  /**
   * Dirty flags for all fields
   */
 private boolean[] dirtyFields = {false,false,false,false};
 private final boolean[] dirtyFieldsDefault = {false,false,false,false};

  public ArbreCampSkel(String idArea,String idDiccionari,String idPare,String nomArea) {
    this.idArea = idArea;
    this.idDiccionari = idDiccionari;
    this.idPare = idPare;
    this.nomArea = nomArea;
  }

  public ArbreCampSkel(String idArea) {
    this.idArea = idArea;
  }

  public ArbreCampSkel() { 
  }

  /**
    * Type : VARCHAR Name : ID_AREA
    */
    private String idArea;

  /**
    * Type : VARCHAR Name : ID_DICCIONARI
    */
    private String idDiccionari;

  /**
    * Type : VARCHAR Name : ID_PARE
    */
    private String idPare;

  /**
    * Type : VARCHAR Name : NOM_AREA
    */
    private String nomArea;

  /**
    * Sets the value for idArea
    * @param idArea
    */
  public void setIdArea(String idArea) {
    if (idArea.length() > 64)
      this.idArea=idArea.substring(0,64);
    else this.idArea=idArea;
    this.dirty = true;
    dirtyFields[0] = true;
  }

  /**
    * Gets the value for idArea
    */
  public String getIdArea() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idArea;
  }

  /**
    * Sets the value for idDiccionari
    * @param idDiccionari
    */
  public void setIdDiccionari(String idDiccionari) {
    if (idDiccionari.length() > 64)
      this.idDiccionari=idDiccionari.substring(0,64);
    else this.idDiccionari=idDiccionari;
    this.dirty = true;
    dirtyFields[1] = true;
  }

  /**
    * Gets the value for idDiccionari
    */
  public String getIdDiccionari() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idDiccionari;
  }

  /**
    * Sets the value for idPare
    * @param idPare
    */
  public void setIdPare(String idPare) {
    if (idPare.length() > 64)
      this.idPare=idPare.substring(0,64);
    else this.idPare=idPare;
    this.dirty = true;
    dirtyFields[2] = true;
  }

  /**
    * Gets the value for idPare
    */
  public String getIdPare() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idPare;
  }

  /**
    * Sets the value for nomArea
    * @param nomArea
    */
  public void setNomArea(String nomArea) {
    if (nomArea.length() > 500)
      this.nomArea=nomArea.substring(0,500);
    else this.nomArea=nomArea;
    this.dirty = true;
    dirtyFields[3] = true;
  }

  /**
    * Gets the value for nomArea
    */
  public String getNomArea() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return nomArea;
  }

/**
  * Return a boolean if the element with PK exists.
  */
public boolean exists(String idArea)  {
  boolean exists = false;
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  try {
    String sql="SELECT * FROM CO_ARBRE_CAMP" +" where ID_AREA="+formatString(idArea);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    if (rs.next()) {
      exists = true;
    }
  } catch (Exception e) {
    exists = false;
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
  return exists;
}

/**
  * Inserts to the database for table "co_arbre_camp"
  */
public void create(Connection con) throws CreateException {
  Statement stm = null;
  try {
    String sql="INSERT INTO co_arbre_camp (ID_AREA,ID_DICCIONARI,ID_PARE,NOM_AREA) VALUES ("+formatString(idArea)+","+formatString(idDiccionari)+","+formatString(idPare)+","+formatString(nomArea)+")";
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new CreateException("Error inserting row");
  } catch (Exception e) {
    throw new CreateException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Inserts to the database for table "co_arbre_camp"
  */
public void create() throws CreateException {
  Connection con = null;
  Statement stm = null;
  try {
    String sql="INSERT INTO co_arbre_camp (ID_AREA,ID_DICCIONARI,ID_PARE,NOM_AREA) VALUES ("+formatString(idArea)+","+formatString(idDiccionari)+","+formatString(idPare)+","+formatString(nomArea)+")";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new CreateException("Error inserting row");
  } catch (Exception e) {
    throw new CreateException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Updates the current object values into the database.
  */
protected void store(Connection con) throws StoreException {
  if (!dirty)
    return;
  if (!isGlobalDirty())
    return;
  Statement stm = null;
  try {
    String sql="UPDATE co_arbre_camp set ";
    int idx = 0;
    if (dirtyFields[idx++]) {
      sql+="ID_AREA="+formatString(idArea)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_DICCIONARI="+formatString(idDiccionari)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_PARE="+formatString(idPare)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="NOM_AREA="+formatString(nomArea)+",";
    }
    sql=sql.substring(0,sql.length()-1);
    sql=sql+" where ID_AREA="+formatString(idArea);
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1) {
      throw new StoreException("Error updating row");
    }
    dirty = false;
    valid = true;
    dirtyFields = dirtyFieldsDefault;
  } catch (Exception e) {
  throw new StoreException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Updates the current object values into the database.
  */
protected void store() throws StoreException {
  if (!dirty)
    return;
  if (!isGlobalDirty())
    return;
  Connection con = null;
  Statement stm = null;
  try {
    String sql="UPDATE co_arbre_camp set ";
    int idx = 0;
    if (dirtyFields[idx++]) {
      sql+="ID_AREA="+formatString(idArea)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_DICCIONARI="+formatString(idDiccionari)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_PARE="+formatString(idPare)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="NOM_AREA="+formatString(nomArea)+",";
    }
    sql=sql.substring(0,sql.length()-1);
    sql=sql+" where ID_AREA="+formatString(idArea);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1) {
      throw new StoreException("Error updating row");
    }
    dirty = false;
    valid = true;
    dirtyFields = dirtyFieldsDefault;
  } catch (Exception e) {
  throw new StoreException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Deletes from the database for table "co_arbre_camp"
  */
public void remove(Connection con) throws RemoveException {
  Statement stm = null;
  try {
    String sql="DELETE FROM co_arbre_camp WHERE ID_AREA="+formatString(idArea);
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new RemoveException("Error deleting row");
  } catch (Exception e) {
    throw new RemoveException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Deletes from the database for table "co_arbre_camp"
  */
public void remove() throws RemoveException {
  Connection con = null;
  Statement stm = null;
  try {
    String sql="DELETE FROM co_arbre_camp WHERE ID_AREA="+formatString(idArea);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new RemoveException("Error deleting row");
  } catch (Exception e) {
    throw new RemoveException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

public int compareTo(Object o) {
  ArbreCampSkel cn = (ArbreCampSkel) o;
  int result = 0;
  result = this.idArea.compareTo(cn.idArea);
  if (result != 0) { return result; };
  result = this.idDiccionari.compareTo(cn.idDiccionari);
  if (result != 0) { return result; };
  result = this.idPare.compareTo(cn.idPare);
  if (result != 0) { return result; };
  result = this.nomArea.compareTo(cn.nomArea);
  if (result != 0) { return result; };
  return result;
}
/**
  * Finds and return the object of this PK.
  */
public ArbreCampSkel findByPrimaryKey(String idArea) throws FinderException {
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  try {
    String sql="SELECT * FROM CO_ARBRE_CAMP" +" where ID_AREA="+formatString(idArea);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    if (!rs.next()) {
      throw new FinderException("Primary Key not found");
    }
    this.idArea = rs.getString("ID_AREA");
    this.idDiccionari = rs.getString("ID_DICCIONARI");
    this.idPare = rs.getString("ID_PARE");
    this.nomArea = rs.getString("NOM_AREA");
    return this;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Finds and return a List for a generic where.
  */
public List findByGenericWhere(String where) throws FinderException {
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  List result = new ArrayList();
  try {
    String sql="SELECT * FROM CO_ARBRE_CAMP" +" WHERE "+where;
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    while (rs.next()) {
      ArbreCampSkel tmp = (ArbreCampSkel) this.getClass().newInstance();
      tmp.idArea = rs.getString("ID_AREA");
      tmp.idDiccionari = rs.getString("ID_DICCIONARI");
      tmp.idPare = rs.getString("ID_PARE");
      tmp.nomArea = rs.getString("NOM_AREA");
      result.add(tmp);
    }
    return result;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

  protected void load() throws LoadException {
  if (valid)
    return;
  try {
    ArbreCampSkel cn = findByPrimaryKey(idArea);
  cn.setValid(true);
    this.idArea = cn.getIdArea();
    this.idDiccionari = cn.getIdDiccionari();
    this.idPare = cn.getIdPare();
    this.nomArea = cn.getNomArea();
    dirty = false;
    valid = true;
  } catch (FinderException e) {
     throw new LoadException(e.toString());
  }
}

/**
  * Synchronize the current object values into the database.
  */
public void flush() throws Exception{
  try {
    if (dirty) {
      store();
      dirty = false;
    }
  } catch (Exception e) {
    e.printStackTrace();
  throw e;
  }
}
/**
  * Synchronize the current object values into the database.
  */
public void flush(Connection con) throws Exception{
  try {
    if (dirty) {
      store(con);
      dirty = false;
    }
  } catch (Exception e) {
    e.printStackTrace();
  throw e;
  }
}

  public static String formatString(String st) {
    String stString = "null";
    if (st != null) {
      if (st.indexOf("'") != -1)
        st = BdUtils.replaceString(st,"'","''");
      stString = "'"+st+"'";
    }
    return stString;
  }

  public static String formatTimeStamp(Timestamp ts)  {
    String tsString = "null";
    if (ts!=null) {
        tsString = "'"+ts.toString()+"'";
    }
    return tsString;
  }

  public static String formatInteger(int i) {
    if (i == NULL_INT)
      return "NULL";
    else
      return ""+i;
  }

  public static String formatDouble(double d) {
    if (d == NULL_DOUBLE)
      return "NULL";
    else
      return ""+d;
  }

  public static String formatLong(long l) {
    if (l == NULL_LONG)
      return "NULL";
    else
      return ""+l;
  }

  public static String formatShort(double s) {
    if (s == NULL_SHORT)
      return "NULL";
    else
      return ""+s;
  }

  public static String formatFloat(float f) {
    if (f == NULL_FLOAT)
      return "NULL";
    else
      return ""+f;
  }

  public static String formatDate(java.util.Date d)  {
    String tsString = "null";
    if (d!=null) {
        tsString = "'"+d.toString()+"'";
    }
    return tsString;
  }

  public String toString() {
    String result = "\n";
    result+="idArea: "+idArea+"\n";
    result+="idDiccionari: "+idDiccionari+"\n";
    result+="idPare: "+idPare+"\n";
    result+="nomArea: "+nomArea+"\n";
    return result;
  }


  public Element toXml() {
    Document doc = new Document();
    Element main = doc.addElement("ArbreCamp");
    Element elem_1= doc.addElement("idArea");
    elem_1.setText(""+(this.getIdArea() == null || this.getIdArea().equals("null")?"":this.getIdArea()));
    main.addChild(elem_1);
    Element elem_2= doc.addElement("idDiccionari");
    elem_2.setText(""+(this.getIdDiccionari() == null || this.getIdDiccionari().equals("null")?"":this.getIdDiccionari()));
    main.addChild(elem_2);
    Element elem_3= doc.addElement("idPare");
    elem_3.setText(""+(this.getIdPare() == null || this.getIdPare().equals("null")?"":this.getIdPare()));
    main.addChild(elem_3);
    Element elem_4= doc.addElement("nomArea");
    elem_4.setText(""+(this.getNomArea() == null || this.getNomArea().equals("null")?"":this.getNomArea()));
    main.addChild(elem_4);
    doc.addChild(main);
    return doc.getRoot();

  }


  public boolean isDirty() {
    return this.dirty;
  }

  public boolean isValid() {
    return this.valid;
  }

  public void setDirty(boolean dirty) {
    this.dirty = dirty;
    if (this.dirty == false) dirtyFields = dirtyFieldsDefault;
  }

  public void setValid(boolean valid) {
    this.valid = valid;
  }
  public boolean isGlobalDirty(){
  boolean result = false;
  for (int i=0;i<numFields;i++)
    result=result || dirtyFields[i];
  return result;
  }

public Vector findAll() throws FinderException { 
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  Vector v = new Vector();
  try {
    String sql="SELECT * from co_arbre_camp ";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    while (rs.next()) {
      ArbreCampSkel tmp=(ArbreCampSkel) this.getClass().newInstance();
      tmp.idArea = rs.getString("ID_AREA");
      tmp.idDiccionari = rs.getString("ID_DICCIONARI");
      tmp.idPare = rs.getString("ID_PARE");
      tmp.nomArea = rs.getString("NOM_AREA");
      v.add(tmp);
    }
    return v;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}


public Element findAllXml() { 
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  int k=0;
  try {
    String sql="SELECT * from co_arbre_camp ";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    Element queryResult = new Element("query-result");
    while (rs.next()) {
      ArbreCampSkel tmp=new ArbreCampSkel();
      tmp.idArea = rs.getString("ID_AREA");
      tmp.idDiccionari = rs.getString("ID_DICCIONARI");
      tmp.idPare = rs.getString("ID_PARE");
      tmp.nomArea = rs.getString("NOM_AREA");
      Element tmpElem = tmp.toXml();
      tmpElem.setAttribute("rowid",""+k);
      queryResult.addChild(tmpElem);
      k++;
    }
    return queryResult;
  } catch (Exception e) {
    throw new BaseRuntimeException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}


}
