//Generation Date: Wed Nov 21 15:53:28 CET 2007
package com.termcat.bd.beans.skels;

import java.sql.*;
import java.io.*;
import java.util.Vector;
import java.util.List;
import com.termcat.bd.utils.DBConnect;
import com.termcat.bd.exceptions.*;
import electric.xml.*;

import java.util.*;
import java.text.*;

/**
  * DiccionarisSkel
  * Clase para acceder a BD
  * DBTable: co_diccionaris
  * @author collazos
  * -----------------------------------------
  * Database version : 1.0 (2007-04-29)
  * Driver Name : H2 JDBC Driver
  * Driver Version : 1.0
  * Generator version : 2.2.0
  * Generation Date : Wed Nov 21 15:53:28 CET 2007
  * @todo extends this class always !!!
  * 
  */
public class DiccionarisSkel implements Serializable, Comparable {
  public final static String TABLE_NAME = "co_diccionaris"; // (Alias from: co_diccionaris)
  private boolean dirty = false;
  private boolean valid = true;
  public static int numFields = 4;

  /**
   * Random Generated UID for this serializable class
   * <code>serialVersionUID</code>
   */
  private static final long serialVersionUID =3482502829120491160L;

  public static final long NULL_LONG =9223372036854775807L;
  public static final double NULL_DOUBLE =1.7976931348623157E308;
  public static final int NULL_INT =2147483647;
  public static final short NULL_SHORT =32767;
  public static final float NULL_FLOAT =3.4028235E38f;

  /**
   * Dirty flags for all fields
   */
 private boolean[] dirtyFields = {false,false,false,false};
 private final boolean[] dirtyFieldsDefault = {false,false,false,false};

  public DiccionarisSkel(String idDiccionari,String nom,String descripcio,String observacions) {
    this.idDiccionari = idDiccionari;
    this.nom = nom;
    this.descripcio = descripcio;
    this.observacions = observacions;
  }

  public DiccionarisSkel(String idDiccionari) {
    this.idDiccionari = idDiccionari;
  }

  public DiccionarisSkel() { 
  }

  /**
    * Type : VARCHAR Name : ID_DICCIONARI
    */
    private String idDiccionari;

  /**
    * Type : VARCHAR Name : NOM
    */
    private String nom;

  /**
    * Type : VARCHAR Name : DESCRIPCIO
    */
    private String descripcio;

  /**
    * Type : VARCHAR Name : OBSERVACIONS
    */
    private String observacions;

  /**
    * Sets the value for idDiccionari
    * @param idDiccionari
    */
  public void setIdDiccionari(String idDiccionari) {
    if (idDiccionari.length() > 64)
      this.idDiccionari=idDiccionari.substring(0,64);
    else this.idDiccionari=idDiccionari;
    this.dirty = true;
    dirtyFields[0] = true;
  }

  /**
    * Gets the value for idDiccionari
    */
  public String getIdDiccionari() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idDiccionari;
  }

  /**
    * Sets the value for nom
    * @param nom
    */
  public void setNom(String nom) {
    if (nom.length() > 100)
      this.nom=nom.substring(0,100);
    else this.nom=nom;
    this.dirty = true;
    dirtyFields[1] = true;
  }

  /**
    * Gets the value for nom
    */
  public String getNom() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return nom;
  }

  /**
    * Sets the value for descripcio
    * @param descripcio
    */
  public void setDescripcio(String descripcio) {
    if (descripcio.length() > 9000)
      this.descripcio=descripcio.substring(0,9000);
    else this.descripcio=descripcio;
    this.dirty = true;
    dirtyFields[2] = true;
  }

  /**
    * Gets the value for descripcio
    */
  public String getDescripcio() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return descripcio;
  }

  /**
    * Sets the value for observacions
    * @param observacions
    */
  public void setObservacions(String observacions) {
    if (observacions.length() > 9000)
      this.observacions=observacions.substring(0,9000);
    else this.observacions=observacions;
    this.dirty = true;
    dirtyFields[3] = true;
  }

  /**
    * Gets the value for observacions
    */
  public String getObservacions() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return observacions;
  }

/**
  * Return a boolean if the element with PK exists.
  */
public boolean exists(String idDiccionari)  {
  boolean exists = false;
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  try {
    String sql="SELECT * FROM CO_DICCIONARIS" +" where ID_DICCIONARI="+formatString(idDiccionari);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    if (rs.next()) {
      exists = true;
    }
  } catch (Exception e) {
    exists = false;
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
  return exists;
}

/**
  * Inserts to the database for table "co_diccionaris"
  */
public void create(Connection con) throws CreateException {
  Statement stm = null;
  try {
    String sql="INSERT INTO co_diccionaris (ID_DICCIONARI,NOM,DESCRIPCIO,OBSERVACIONS) VALUES ("+formatString(idDiccionari)+","+formatString(nom)+","+formatString(descripcio)+","+formatString(observacions)+")";
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new CreateException("Error inserting row");
  } catch (Exception e) {
    throw new CreateException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Inserts to the database for table "co_diccionaris"
  */
public void create() throws CreateException {
  Connection con = null;
  Statement stm = null;
  try {
    String sql="INSERT INTO co_diccionaris (ID_DICCIONARI,NOM,DESCRIPCIO,OBSERVACIONS) VALUES ("+formatString(idDiccionari)+","+formatString(nom)+","+formatString(descripcio)+","+formatString(observacions)+")";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new CreateException("Error inserting row");
  } catch (Exception e) {
    throw new CreateException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Updates the current object values into the database.
  */
protected void store(Connection con) throws StoreException {
  if (!dirty)
    return;
  if (!isGlobalDirty())
    return;
  Statement stm = null;
  try {
    String sql="UPDATE co_diccionaris set ";
    int idx = 0;
    if (dirtyFields[idx++]) {
      sql+="ID_DICCIONARI="+formatString(idDiccionari)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="NOM="+formatString(nom)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="DESCRIPCIO="+formatString(descripcio)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="OBSERVACIONS="+formatString(observacions)+",";
    }
    sql=sql.substring(0,sql.length()-1);
    sql=sql+" where ID_DICCIONARI="+formatString(idDiccionari);
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1) {
      throw new StoreException("Error updating row");
    }
    dirty = false;
    valid = true;
    dirtyFields = dirtyFieldsDefault;
  } catch (Exception e) {
  throw new StoreException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Updates the current object values into the database.
  */
protected void store() throws StoreException {
  if (!dirty)
    return;
  if (!isGlobalDirty())
    return;
  Connection con = null;
  Statement stm = null;
  try {
    String sql="UPDATE co_diccionaris set ";
    int idx = 0;
    if (dirtyFields[idx++]) {
      sql+="ID_DICCIONARI="+formatString(idDiccionari)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="NOM="+formatString(nom)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="DESCRIPCIO="+formatString(descripcio)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="OBSERVACIONS="+formatString(observacions)+",";
    }
    sql=sql.substring(0,sql.length()-1);
    sql=sql+" where ID_DICCIONARI="+formatString(idDiccionari);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1) {
      throw new StoreException("Error updating row");
    }
    dirty = false;
    valid = true;
    dirtyFields = dirtyFieldsDefault;
  } catch (Exception e) {
  throw new StoreException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Deletes from the database for table "co_diccionaris"
  */
public void remove(Connection con) throws RemoveException {
  Statement stm = null;
  try {
    String sql="DELETE FROM co_diccionaris WHERE ID_DICCIONARI="+formatString(idDiccionari);
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new RemoveException("Error deleting row");
  } catch (Exception e) {
    throw new RemoveException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Deletes from the database for table "co_diccionaris"
  */
public void remove() throws RemoveException {
  Connection con = null;
  Statement stm = null;
  try {
    String sql="DELETE FROM co_diccionaris WHERE ID_DICCIONARI="+formatString(idDiccionari);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new RemoveException("Error deleting row");
  } catch (Exception e) {
    throw new RemoveException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

public int compareTo(Object o) {
  DiccionarisSkel cn = (DiccionarisSkel) o;
  int result = 0;
  result = this.idDiccionari.compareTo(cn.idDiccionari);
  if (result != 0) { return result; };
  result = this.nom.compareTo(cn.nom);
  if (result != 0) { return result; };
  result = this.descripcio.compareTo(cn.descripcio);
  if (result != 0) { return result; };
  result = this.observacions.compareTo(cn.observacions);
  if (result != 0) { return result; };
  return result;
}
/**
  * Finds and return the object of this PK.
  */
public DiccionarisSkel findByPrimaryKey(String idDiccionari) throws FinderException {
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  try {
    String sql="SELECT * FROM CO_DICCIONARIS" +" where ID_DICCIONARI="+formatString(idDiccionari);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    if (!rs.next()) {
      throw new FinderException("Primary Key not found");
    }
    this.idDiccionari = rs.getString("ID_DICCIONARI");
    this.nom = rs.getString("NOM");
    this.descripcio = rs.getString("DESCRIPCIO");
    this.observacions = rs.getString("OBSERVACIONS");
    return this;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Finds and return a List for a generic where.
  */
public List findByGenericWhere(String where) throws FinderException {
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  List result = new ArrayList();
  try {
    String sql="SELECT * FROM CO_DICCIONARIS" +" WHERE "+where;
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    while (rs.next()) {
      DiccionarisSkel tmp = (DiccionarisSkel) this.getClass().newInstance();
      tmp.idDiccionari = rs.getString("ID_DICCIONARI");
      tmp.nom = rs.getString("NOM");
      tmp.descripcio = rs.getString("DESCRIPCIO");
      tmp.observacions = rs.getString("OBSERVACIONS");
      result.add(tmp);
    }
    return result;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

  protected void load() throws LoadException {
  if (valid)
    return;
  try {
    DiccionarisSkel cn = findByPrimaryKey(idDiccionari);
  cn.setValid(true);
    this.idDiccionari = cn.getIdDiccionari();
    this.nom = cn.getNom();
    this.descripcio = cn.getDescripcio();
    this.observacions = cn.getObservacions();
    dirty = false;
    valid = true;
  } catch (FinderException e) {
     throw new LoadException(e.toString());
  }
}

/**
  * Synchronize the current object values into the database.
  */
public void flush() throws Exception{
  try {
    if (dirty) {
      store();
      dirty = false;
    }
  } catch (Exception e) {
    e.printStackTrace();
  throw e;
  }
}
/**
  * Synchronize the current object values into the database.
  */
public void flush(Connection con) throws Exception{
  try {
    if (dirty) {
      store(con);
      dirty = false;
    }
  } catch (Exception e) {
    e.printStackTrace();
  throw e;
  }
}

  public static String formatString(String st) {
    String stString = "null";
    if (st != null) {
      if (st.indexOf("'") != -1)
        st = BdUtils.replaceString(st,"'","''");
      stString = "'"+st+"'";
    }
    return stString;
  }

  public static String formatTimeStamp(Timestamp ts)  {
    String tsString = "null";
    if (ts!=null) {
        tsString = "'"+ts.toString()+"'";
    }
    return tsString;
  }

  public static String formatInteger(int i) {
    if (i == NULL_INT)
      return "NULL";
    else
      return ""+i;
  }

  public static String formatDouble(double d) {
    if (d == NULL_DOUBLE)
      return "NULL";
    else
      return ""+d;
  }

  public static String formatLong(long l) {
    if (l == NULL_LONG)
      return "NULL";
    else
      return ""+l;
  }

  public static String formatShort(double s) {
    if (s == NULL_SHORT)
      return "NULL";
    else
      return ""+s;
  }

  public static String formatFloat(float f) {
    if (f == NULL_FLOAT)
      return "NULL";
    else
      return ""+f;
  }

  public static String formatDate(java.util.Date d)  {
    String tsString = "null";
    if (d!=null) {
        tsString = "'"+d.toString()+"'";
    }
    return tsString;
  }

  public String toString() {
    String result = "\n";
    result+="idDiccionari: "+idDiccionari+"\n";
    result+="nom: "+nom+"\n";
    result+="descripcio: "+descripcio+"\n";
    result+="observacions: "+observacions+"\n";
    return result;
  }


  public Element toXml() {
    Document doc = new Document();
    Element main = doc.addElement("Diccionaris");
    Element elem_1= doc.addElement("idDiccionari");
    elem_1.setText(""+(this.getIdDiccionari() == null || this.getIdDiccionari().equals("null")?"":this.getIdDiccionari()));
    main.addChild(elem_1);
    Element elem_2= doc.addElement("nom");
    elem_2.setText(""+(this.getNom() == null || this.getNom().equals("null")?"":this.getNom()));
    main.addChild(elem_2);
    Element elem_3= doc.addElement("descripcio");
    elem_3.setText(""+(this.getDescripcio() == null || this.getDescripcio().equals("null")?"":this.getDescripcio()));
    main.addChild(elem_3);
    Element elem_4= doc.addElement("observacions");
    elem_4.setText(""+(this.getObservacions() == null || this.getObservacions().equals("null")?"":this.getObservacions()));
    main.addChild(elem_4);
    doc.addChild(main);
    return doc.getRoot();

  }


  public boolean isDirty() {
    return this.dirty;
  }

  public boolean isValid() {
    return this.valid;
  }

  public void setDirty(boolean dirty) {
    this.dirty = dirty;
    if (this.dirty == false) dirtyFields = dirtyFieldsDefault;
  }

  public void setValid(boolean valid) {
    this.valid = valid;
  }
  public boolean isGlobalDirty(){
  boolean result = false;
  for (int i=0;i<numFields;i++)
    result=result || dirtyFields[i];
  return result;
  }

public Vector findAll() throws FinderException { 
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  Vector v = new Vector();
  try {
    String sql="SELECT * from co_diccionaris ";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    while (rs.next()) {
      DiccionarisSkel tmp=(DiccionarisSkel) this.getClass().newInstance();
      tmp.idDiccionari = rs.getString("ID_DICCIONARI");
      tmp.nom = rs.getString("NOM");
      tmp.descripcio = rs.getString("DESCRIPCIO");
      tmp.observacions = rs.getString("OBSERVACIONS");
      v.add(tmp);
    }
    return v;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}


public Element findAllXml() { 
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  int k=0;
  try {
    String sql="SELECT * from co_diccionaris ";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    Element queryResult = new Element("query-result");
    while (rs.next()) {
      DiccionarisSkel tmp=new DiccionarisSkel();
      tmp.idDiccionari = rs.getString("ID_DICCIONARI");
      tmp.nom = rs.getString("NOM");
      tmp.descripcio = rs.getString("DESCRIPCIO");
      tmp.observacions = rs.getString("OBSERVACIONS");
      Element tmpElem = tmp.toXml();
      tmpElem.setAttribute("rowid",""+k);
      queryResult.addChild(tmpElem);
      k++;
    }
    return queryResult;
  } catch (Exception e) {
    throw new BaseRuntimeException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}


}
