//Generation Date: Wed Nov 21 15:53:29 CET 2007
package com.termcat.bd.beans.skels;

import java.sql.*;
import java.io.*;
import java.util.Vector;
import java.util.List;
import com.termcat.bd.utils.DBConnect;
import com.termcat.bd.exceptions.*;
import electric.xml.*;

import java.util.*;
import java.text.*;

/**
  * FontsDenominacionsSkel
  * Clase para acceder a BD
  * DBTable: co_fonts_denominacions
  * @author collazos
  * -----------------------------------------
  * Database version : 1.0 (2007-04-29)
  * Driver Name : H2 JDBC Driver
  * Driver Version : 1.0
  * Generator version : 2.2.0
  * Generation Date : Wed Nov 21 15:53:29 CET 2007
  * @todo extends this class always !!!
  * 
  */
public class FontsDenominacionsSkel implements Serializable, Comparable {
  public final static String TABLE_NAME = "co_fonts_denominacions"; // (Alias from: co_fonts_denominacions)
  private boolean dirty = false;
  private boolean valid = true;
  public static int numFields = 2;

  /**
   * Random Generated UID for this serializable class
   * <code>serialVersionUID</code>
   */
  private static final long serialVersionUID =-4011893393535762641L;

  public static final long NULL_LONG =9223372036854775807L;
  public static final double NULL_DOUBLE =1.7976931348623157E308;
  public static final int NULL_INT =2147483647;
  public static final short NULL_SHORT =32767;
  public static final float NULL_FLOAT =3.4028235E38f;

  /**
   * Dirty flags for all fields
   */
 private boolean[] dirtyFields = {false,false};
 private final boolean[] dirtyFieldsDefault = {false,false};

  public FontsDenominacionsSkel(String idDenominacio,String idFont) {
    this.idDenominacio = idDenominacio;
    this.idFont = idFont;
  }

  public FontsDenominacionsSkel() { 
  }

  /**
    * Type : VARCHAR Name : ID_DENOMINACIO
    */
    private String idDenominacio;

  /**
    * Type : VARCHAR Name : ID_FONT
    */
    private String idFont;

  /**
    * Sets the value for idDenominacio
    * @param idDenominacio
    */
  public void setIdDenominacio(String idDenominacio) {
    if (idDenominacio.length() > 64)
      this.idDenominacio=idDenominacio.substring(0,64);
    else this.idDenominacio=idDenominacio;
    this.dirty = true;
    dirtyFields[0] = true;
  }

  /**
    * Gets the value for idDenominacio
    */
  public String getIdDenominacio() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idDenominacio;
  }

  /**
    * Sets the value for idFont
    * @param idFont
    */
  public void setIdFont(String idFont) {
    if (idFont.length() > 64)
      this.idFont=idFont.substring(0,64);
    else this.idFont=idFont;
    this.dirty = true;
    dirtyFields[1] = true;
  }

  /**
    * Gets the value for idFont
    */
  public String getIdFont() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idFont;
  }

/**
  * Return a boolean if the element with PK exists.
  */
public boolean exists(String idDenominacio,String idFont)  {
  boolean exists = false;
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  try {
    String sql="SELECT * FROM CO_FONTS_DENOMINACIONS" +" where ID_DENOMINACIO="+formatString(idDenominacio)+" and ID_FONT="+formatString(idFont);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    if (rs.next()) {
      exists = true;
    }
  } catch (Exception e) {
    exists = false;
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
  return exists;
}

/**
  * Inserts to the database for table "co_fonts_denominacions"
  */
public void create(Connection con) throws CreateException {
  Statement stm = null;
  try {
    String sql="INSERT INTO co_fonts_denominacions (ID_DENOMINACIO,ID_FONT) VALUES ("+formatString(idDenominacio)+","+formatString(idFont)+")";
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new CreateException("Error inserting row");
  } catch (Exception e) {
    throw new CreateException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Inserts to the database for table "co_fonts_denominacions"
  */
public void create() throws CreateException {
  Connection con = null;
  Statement stm = null;
  try {
    String sql="INSERT INTO co_fonts_denominacions (ID_DENOMINACIO,ID_FONT) VALUES ("+formatString(idDenominacio)+","+formatString(idFont)+")";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new CreateException("Error inserting row");
  } catch (Exception e) {
    throw new CreateException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Updates the current object values into the database.
  */
protected void store(Connection con) throws StoreException {
  if (!dirty)
    return;
  if (!isGlobalDirty())
    return;
  Statement stm = null;
  try {
    String sql="UPDATE co_fonts_denominacions set ";
    int idx = 0;
    if (dirtyFields[idx++]) {
      sql+="ID_DENOMINACIO="+formatString(idDenominacio)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_FONT="+formatString(idFont)+",";
    }
    sql=sql.substring(0,sql.length()-1);
    sql=sql+" where ID_DENOMINACIO="+formatString(idDenominacio)+" and ID_FONT="+formatString(idFont);
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1) {
      throw new StoreException("Error updating row");
    }
    dirty = false;
    valid = true;
    dirtyFields = dirtyFieldsDefault;
  } catch (Exception e) {
  throw new StoreException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Updates the current object values into the database.
  */
protected void store() throws StoreException {
  if (!dirty)
    return;
  if (!isGlobalDirty())
    return;
  Connection con = null;
  Statement stm = null;
  try {
    String sql="UPDATE co_fonts_denominacions set ";
    int idx = 0;
    if (dirtyFields[idx++]) {
      sql+="ID_DENOMINACIO="+formatString(idDenominacio)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_FONT="+formatString(idFont)+",";
    }
    sql=sql.substring(0,sql.length()-1);
    sql=sql+" where ID_DENOMINACIO="+formatString(idDenominacio)+" and ID_FONT="+formatString(idFont);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1) {
      throw new StoreException("Error updating row");
    }
    dirty = false;
    valid = true;
    dirtyFields = dirtyFieldsDefault;
  } catch (Exception e) {
  throw new StoreException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Deletes from the database for table "co_fonts_denominacions"
  */
public void remove(Connection con) throws RemoveException {
  Statement stm = null;
  try {
    String sql="DELETE FROM co_fonts_denominacions WHERE ID_DENOMINACIO="+formatString(idDenominacio)+" and ID_FONT="+formatString(idFont);
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new RemoveException("Error deleting row");
  } catch (Exception e) {
    throw new RemoveException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Deletes from the database for table "co_fonts_denominacions"
  */
public void remove() throws RemoveException {
  Connection con = null;
  Statement stm = null;
  try {
    String sql="DELETE FROM co_fonts_denominacions WHERE ID_DENOMINACIO="+formatString(idDenominacio)+" and ID_FONT="+formatString(idFont);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new RemoveException("Error deleting row");
  } catch (Exception e) {
    throw new RemoveException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

public int compareTo(Object o) {
  FontsDenominacionsSkel cn = (FontsDenominacionsSkel) o;
  int result = 0;
  result = this.idDenominacio.compareTo(cn.idDenominacio);
  if (result != 0) { return result; };
  result = this.idFont.compareTo(cn.idFont);
  if (result != 0) { return result; };
  return result;
}
/**
  * Finds and return the object of this PK.
  */
public FontsDenominacionsSkel findByPrimaryKey(String idDenominacio,String idFont) throws FinderException {
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  try {
    String sql="SELECT * FROM CO_FONTS_DENOMINACIONS" +" where ID_DENOMINACIO="+formatString(idDenominacio)+" and ID_FONT="+formatString(idFont);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    if (!rs.next()) {
      throw new FinderException("Primary Key not found");
    }
    this.idDenominacio = rs.getString("ID_DENOMINACIO");
    this.idFont = rs.getString("ID_FONT");
    return this;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Finds and return a List for a generic where.
  */
public List findByGenericWhere(String where) throws FinderException {
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  List result = new ArrayList();
  try {
    String sql="SELECT * FROM CO_FONTS_DENOMINACIONS" +" WHERE "+where;
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    while (rs.next()) {
      FontsDenominacionsSkel tmp = (FontsDenominacionsSkel) this.getClass().newInstance();
      tmp.idDenominacio = rs.getString("ID_DENOMINACIO");
      tmp.idFont = rs.getString("ID_FONT");
      result.add(tmp);
    }
    return result;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

  protected void load() throws LoadException {
  if (valid)
    return;
  try {
    FontsDenominacionsSkel cn = findByPrimaryKey(idDenominacio,idFont);
  cn.setValid(true);
    this.idDenominacio = cn.getIdDenominacio();
    this.idFont = cn.getIdFont();
    dirty = false;
    valid = true;
  } catch (FinderException e) {
     throw new LoadException(e.toString());
  }
}

/**
  * Synchronize the current object values into the database.
  */
public void flush() throws Exception{
  try {
    if (dirty) {
      store();
      dirty = false;
    }
  } catch (Exception e) {
    e.printStackTrace();
  throw e;
  }
}
/**
  * Synchronize the current object values into the database.
  */
public void flush(Connection con) throws Exception{
  try {
    if (dirty) {
      store(con);
      dirty = false;
    }
  } catch (Exception e) {
    e.printStackTrace();
  throw e;
  }
}

  public static String formatString(String st) {
    String stString = "null";
    if (st != null) {
      if (st.indexOf("'") != -1)
        st = BdUtils.replaceString(st,"'","''");
      stString = "'"+st+"'";
    }
    return stString;
  }

  public static String formatTimeStamp(Timestamp ts)  {
    String tsString = "null";
    if (ts!=null) {
        tsString = "'"+ts.toString()+"'";
    }
    return tsString;
  }

  public static String formatInteger(int i) {
    if (i == NULL_INT)
      return "NULL";
    else
      return ""+i;
  }

  public static String formatDouble(double d) {
    if (d == NULL_DOUBLE)
      return "NULL";
    else
      return ""+d;
  }

  public static String formatLong(long l) {
    if (l == NULL_LONG)
      return "NULL";
    else
      return ""+l;
  }

  public static String formatShort(double s) {
    if (s == NULL_SHORT)
      return "NULL";
    else
      return ""+s;
  }

  public static String formatFloat(float f) {
    if (f == NULL_FLOAT)
      return "NULL";
    else
      return ""+f;
  }

  public static String formatDate(java.util.Date d)  {
    String tsString = "null";
    if (d!=null) {
        tsString = "'"+d.toString()+"'";
    }
    return tsString;
  }

  public String toString() {
    String result = "\n";
    result+="idDenominacio: "+idDenominacio+"\n";
    result+="idFont: "+idFont+"\n";
    return result;
  }


  public Element toXml() {
    Document doc = new Document();
    Element main = doc.addElement("FontsDenominacions");
    Element elem_1= doc.addElement("idDenominacio");
    elem_1.setText(""+(this.getIdDenominacio() == null || this.getIdDenominacio().equals("null")?"":this.getIdDenominacio()));
    main.addChild(elem_1);
    Element elem_2= doc.addElement("idFont");
    elem_2.setText(""+(this.getIdFont() == null || this.getIdFont().equals("null")?"":this.getIdFont()));
    main.addChild(elem_2);
    doc.addChild(main);
    return doc.getRoot();

  }


  public boolean isDirty() {
    return this.dirty;
  }

  public boolean isValid() {
    return this.valid;
  }

  public void setDirty(boolean dirty) {
    this.dirty = dirty;
    if (this.dirty == false) dirtyFields = dirtyFieldsDefault;
  }

  public void setValid(boolean valid) {
    this.valid = valid;
  }
  public boolean isGlobalDirty(){
  boolean result = false;
  for (int i=0;i<numFields;i++)
    result=result || dirtyFields[i];
  return result;
  }

public Vector findAll() throws FinderException { 
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  Vector v = new Vector();
  try {
    String sql="SELECT * from co_fonts_denominacions ";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    while (rs.next()) {
      FontsDenominacionsSkel tmp=(FontsDenominacionsSkel) this.getClass().newInstance();
      tmp.idDenominacio = rs.getString("ID_DENOMINACIO");
      tmp.idFont = rs.getString("ID_FONT");
      v.add(tmp);
    }
    return v;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}


public Element findAllXml() { 
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  int k=0;
  try {
    String sql="SELECT * from co_fonts_denominacions ";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    Element queryResult = new Element("query-result");
    while (rs.next()) {
      FontsDenominacionsSkel tmp=new FontsDenominacionsSkel();
      tmp.idDenominacio = rs.getString("ID_DENOMINACIO");
      tmp.idFont = rs.getString("ID_FONT");
      Element tmpElem = tmp.toXml();
      tmpElem.setAttribute("rowid",""+k);
      queryResult.addChild(tmpElem);
      k++;
    }
    return queryResult;
  } catch (Exception e) {
    throw new BaseRuntimeException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}


}
