//Generation Date: Wed Nov 21 15:53:29 CET 2007
package com.termcat.bd.beans.skels;

import java.sql.*;
import java.io.*;
import java.util.Vector;
import java.util.List;
import com.termcat.bd.utils.DBConnect;
import com.termcat.bd.exceptions.*;
import electric.xml.*;

import java.util.*;
import java.text.*;

/**
  * JerarquiesSkel
  * Clase para acceder a BD
  * DBTable: co_jerarquies
  * @author collazos
  * -----------------------------------------
  * Database version : 1.0 (2007-04-29)
  * Driver Name : H2 JDBC Driver
  * Driver Version : 1.0
  * Generator version : 2.2.0
  * Generation Date : Wed Nov 21 15:53:29 CET 2007
  * @todo extends this class always !!!
  * 
  */
public class JerarquiesSkel implements Serializable, Comparable {
  public final static String TABLE_NAME = "co_jerarquies"; // (Alias from: co_jerarquies)
  private boolean dirty = false;
  private boolean valid = true;
  public static int numFields = 4;

  /**
   * Random Generated UID for this serializable class
   * <code>serialVersionUID</code>
   */
  private static final long serialVersionUID =-4894002781196110702L;

  public static final long NULL_LONG =9223372036854775807L;
  public static final double NULL_DOUBLE =1.7976931348623157E308;
  public static final int NULL_INT =2147483647;
  public static final short NULL_SHORT =32767;
  public static final float NULL_FLOAT =3.4028235E38f;

  /**
   * Dirty flags for all fields
   */
 private boolean[] dirtyFields = {false,false,false,false};
 private final boolean[] dirtyFieldsDefault = {false,false,false,false};

  public JerarquiesSkel(String idJerarquia,String codiJerarquia,String descripcio,long prioritat) {
    this.idJerarquia = idJerarquia;
    this.codiJerarquia = codiJerarquia;
    this.descripcio = descripcio;
    this.prioritat = prioritat;
  }

  public JerarquiesSkel(String idJerarquia) {
    this.idJerarquia = idJerarquia;
  }

  public JerarquiesSkel() { 
  }

  /**
    * Type : VARCHAR Name : ID_JERARQUIA
    */
    private String idJerarquia;

  /**
    * Type : VARCHAR Name : CODI_JERARQUIA
    */
    private String codiJerarquia;

  /**
    * Type : VARCHAR Name : DESCRIPCIO
    */
    private String descripcio;

  /**
    * Type : BIGINT Name : PRIORITAT
    */
    private long prioritat;

  /**
    * Sets the value for idJerarquia
    * @param idJerarquia
    */
  public void setIdJerarquia(String idJerarquia) {
    if (idJerarquia.length() > 64)
      this.idJerarquia=idJerarquia.substring(0,64);
    else this.idJerarquia=idJerarquia;
    this.dirty = true;
    dirtyFields[0] = true;
  }

  /**
    * Gets the value for idJerarquia
    */
  public String getIdJerarquia() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idJerarquia;
  }

  /**
    * Sets the value for codiJerarquia
    * @param codiJerarquia
    */
  public void setCodiJerarquia(String codiJerarquia) {
    if (codiJerarquia.length() > 100)
      this.codiJerarquia=codiJerarquia.substring(0,100);
    else this.codiJerarquia=codiJerarquia;
    this.dirty = true;
    dirtyFields[1] = true;
  }

  /**
    * Gets the value for codiJerarquia
    */
  public String getCodiJerarquia() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return codiJerarquia;
  }

  /**
    * Sets the value for descripcio
    * @param descripcio
    */
  public void setDescripcio(String descripcio) {
    if (descripcio.length() > 400)
      this.descripcio=descripcio.substring(0,400);
    else this.descripcio=descripcio;
    this.dirty = true;
    dirtyFields[2] = true;
  }

  /**
    * Gets the value for descripcio
    */
  public String getDescripcio() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return descripcio;
  }

  /**
    * Sets the value for prioritat
    * @param prioritat
    */
  public void setPrioritat(long prioritat) {
    this.prioritat=prioritat;
    this.dirty = true;
    dirtyFields[3] = true;
  }

  /**
    * Gets the value for prioritat
    */
  public long getPrioritat() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return prioritat;
  }

/**
  * Return a boolean if the element with PK exists.
  */
public boolean exists(String idJerarquia)  {
  boolean exists = false;
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  try {
    String sql="SELECT * FROM CO_JERARQUIES" +" where ID_JERARQUIA="+formatString(idJerarquia);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    if (rs.next()) {
      exists = true;
    }
  } catch (Exception e) {
    exists = false;
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
  return exists;
}

/**
  * Inserts to the database for table "co_jerarquies"
  */
public void create(Connection con) throws CreateException {
  Statement stm = null;
  try {
    String sql="INSERT INTO co_jerarquies (ID_JERARQUIA,CODI_JERARQUIA,DESCRIPCIO,PRIORITAT) VALUES ("+formatString(idJerarquia)+","+formatString(codiJerarquia)+","+formatString(descripcio)+","+formatLong(prioritat)+")";
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new CreateException("Error inserting row");
  } catch (Exception e) {
    throw new CreateException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Inserts to the database for table "co_jerarquies"
  */
public void create() throws CreateException {
  Connection con = null;
  Statement stm = null;
  try {
    String sql="INSERT INTO co_jerarquies (ID_JERARQUIA,CODI_JERARQUIA,DESCRIPCIO,PRIORITAT) VALUES ("+formatString(idJerarquia)+","+formatString(codiJerarquia)+","+formatString(descripcio)+","+formatLong(prioritat)+")";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new CreateException("Error inserting row");
  } catch (Exception e) {
    throw new CreateException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Updates the current object values into the database.
  */
protected void store(Connection con) throws StoreException {
  if (!dirty)
    return;
  if (!isGlobalDirty())
    return;
  Statement stm = null;
  try {
    String sql="UPDATE co_jerarquies set ";
    int idx = 0;
    if (dirtyFields[idx++]) {
      sql+="ID_JERARQUIA="+formatString(idJerarquia)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="CODI_JERARQUIA="+formatString(codiJerarquia)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="DESCRIPCIO="+formatString(descripcio)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="PRIORITAT="+formatLong(prioritat)+",";
    }
    sql=sql.substring(0,sql.length()-1);
    sql=sql+" where ID_JERARQUIA="+formatString(idJerarquia);
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1) {
      throw new StoreException("Error updating row");
    }
    dirty = false;
    valid = true;
    dirtyFields = dirtyFieldsDefault;
  } catch (Exception e) {
  throw new StoreException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Updates the current object values into the database.
  */
protected void store() throws StoreException {
  if (!dirty)
    return;
  if (!isGlobalDirty())
    return;
  Connection con = null;
  Statement stm = null;
  try {
    String sql="UPDATE co_jerarquies set ";
    int idx = 0;
    if (dirtyFields[idx++]) {
      sql+="ID_JERARQUIA="+formatString(idJerarquia)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="CODI_JERARQUIA="+formatString(codiJerarquia)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="DESCRIPCIO="+formatString(descripcio)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="PRIORITAT="+formatLong(prioritat)+",";
    }
    sql=sql.substring(0,sql.length()-1);
    sql=sql+" where ID_JERARQUIA="+formatString(idJerarquia);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1) {
      throw new StoreException("Error updating row");
    }
    dirty = false;
    valid = true;
    dirtyFields = dirtyFieldsDefault;
  } catch (Exception e) {
  throw new StoreException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Deletes from the database for table "co_jerarquies"
  */
public void remove(Connection con) throws RemoveException {
  Statement stm = null;
  try {
    String sql="DELETE FROM co_jerarquies WHERE ID_JERARQUIA="+formatString(idJerarquia);
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new RemoveException("Error deleting row");
  } catch (Exception e) {
    throw new RemoveException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Deletes from the database for table "co_jerarquies"
  */
public void remove() throws RemoveException {
  Connection con = null;
  Statement stm = null;
  try {
    String sql="DELETE FROM co_jerarquies WHERE ID_JERARQUIA="+formatString(idJerarquia);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new RemoveException("Error deleting row");
  } catch (Exception e) {
    throw new RemoveException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

public int compareTo(Object o) {
  JerarquiesSkel cn = (JerarquiesSkel) o;
  int result = 0;
  result = this.idJerarquia.compareTo(cn.idJerarquia);
  if (result != 0) { return result; };
  result = this.codiJerarquia.compareTo(cn.codiJerarquia);
  if (result != 0) { return result; };
  result = this.descripcio.compareTo(cn.descripcio);
  if (result != 0) { return result; };
  result = (new Long(this.prioritat).compareTo(new Long(cn.prioritat)));
  if (result != 0) { return result; };
  return result;
}
/**
  * Finds and return the object of this PK.
  */
public JerarquiesSkel findByPrimaryKey(String idJerarquia) throws FinderException {
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  try {
    String sql="SELECT * FROM CO_JERARQUIES" +" where ID_JERARQUIA="+formatString(idJerarquia);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    if (!rs.next()) {
      throw new FinderException("Primary Key not found");
    }
    this.idJerarquia = rs.getString("ID_JERARQUIA");
    this.codiJerarquia = rs.getString("CODI_JERARQUIA");
    this.descripcio = rs.getString("DESCRIPCIO");
    this.prioritat = rs.getLong("PRIORITAT");
    return this;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Finds and return a List for a generic where.
  */
public List findByGenericWhere(String where) throws FinderException {
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  List result = new ArrayList();
  try {
    String sql="SELECT * FROM CO_JERARQUIES" +" WHERE "+where;
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    while (rs.next()) {
      JerarquiesSkel tmp = (JerarquiesSkel) this.getClass().newInstance();
      tmp.idJerarquia = rs.getString("ID_JERARQUIA");
      tmp.codiJerarquia = rs.getString("CODI_JERARQUIA");
      tmp.descripcio = rs.getString("DESCRIPCIO");
      tmp.prioritat = rs.getLong("PRIORITAT");
      result.add(tmp);
    }
    return result;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

  protected void load() throws LoadException {
  if (valid)
    return;
  try {
    JerarquiesSkel cn = findByPrimaryKey(idJerarquia);
  cn.setValid(true);
    this.idJerarquia = cn.getIdJerarquia();
    this.codiJerarquia = cn.getCodiJerarquia();
    this.descripcio = cn.getDescripcio();
    this.prioritat = cn.getPrioritat();
    dirty = false;
    valid = true;
  } catch (FinderException e) {
     throw new LoadException(e.toString());
  }
}

/**
  * Synchronize the current object values into the database.
  */
public void flush() throws Exception{
  try {
    if (dirty) {
      store();
      dirty = false;
    }
  } catch (Exception e) {
    e.printStackTrace();
  throw e;
  }
}
/**
  * Synchronize the current object values into the database.
  */
public void flush(Connection con) throws Exception{
  try {
    if (dirty) {
      store(con);
      dirty = false;
    }
  } catch (Exception e) {
    e.printStackTrace();
  throw e;
  }
}

  public static String formatString(String st) {
    String stString = "null";
    if (st != null) {
      if (st.indexOf("'") != -1)
        st = BdUtils.replaceString(st,"'","''");
      stString = "'"+st+"'";
    }
    return stString;
  }

  public static String formatTimeStamp(Timestamp ts)  {
    String tsString = "null";
    if (ts!=null) {
        tsString = "'"+ts.toString()+"'";
    }
    return tsString;
  }

  public static String formatInteger(int i) {
    if (i == NULL_INT)
      return "NULL";
    else
      return ""+i;
  }

  public static String formatDouble(double d) {
    if (d == NULL_DOUBLE)
      return "NULL";
    else
      return ""+d;
  }

  public static String formatLong(long l) {
    if (l == NULL_LONG)
      return "NULL";
    else
      return ""+l;
  }

  public static String formatShort(double s) {
    if (s == NULL_SHORT)
      return "NULL";
    else
      return ""+s;
  }

  public static String formatFloat(float f) {
    if (f == NULL_FLOAT)
      return "NULL";
    else
      return ""+f;
  }

  public static String formatDate(java.util.Date d)  {
    String tsString = "null";
    if (d!=null) {
        tsString = "'"+d.toString()+"'";
    }
    return tsString;
  }

  public String toString() {
    String result = "\n";
    result+="idJerarquia: "+idJerarquia+"\n";
    result+="codiJerarquia: "+codiJerarquia+"\n";
    result+="descripcio: "+descripcio+"\n";
    result+="prioritat: "+prioritat+"\n";
    return result;
  }


  public Element toXml() {
    Document doc = new Document();
    Element main = doc.addElement("Jerarquies");
    Element elem_1= doc.addElement("idJerarquia");
    elem_1.setText(""+(this.getIdJerarquia() == null || this.getIdJerarquia().equals("null")?"":this.getIdJerarquia()));
    main.addChild(elem_1);
    Element elem_2= doc.addElement("codiJerarquia");
    elem_2.setText(""+(this.getCodiJerarquia() == null || this.getCodiJerarquia().equals("null")?"":this.getCodiJerarquia()));
    main.addChild(elem_2);
    Element elem_3= doc.addElement("descripcio");
    elem_3.setText(""+(this.getDescripcio() == null || this.getDescripcio().equals("null")?"":this.getDescripcio()));
    main.addChild(elem_3);
    Element elem_4= doc.addElement("prioritat");
    elem_4.setText(""+this.getPrioritat());
    main.addChild(elem_4);
    doc.addChild(main);
    return doc.getRoot();

  }


  public boolean isDirty() {
    return this.dirty;
  }

  public boolean isValid() {
    return this.valid;
  }

  public void setDirty(boolean dirty) {
    this.dirty = dirty;
    if (this.dirty == false) dirtyFields = dirtyFieldsDefault;
  }

  public void setValid(boolean valid) {
    this.valid = valid;
  }
  public boolean isGlobalDirty(){
  boolean result = false;
  for (int i=0;i<numFields;i++)
    result=result || dirtyFields[i];
  return result;
  }

public Vector findAll() throws FinderException { 
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  Vector v = new Vector();
  try {
    String sql="SELECT * from co_jerarquies ";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    while (rs.next()) {
      JerarquiesSkel tmp=(JerarquiesSkel) this.getClass().newInstance();
      tmp.idJerarquia = rs.getString("ID_JERARQUIA");
      tmp.codiJerarquia = rs.getString("CODI_JERARQUIA");
      tmp.descripcio = rs.getString("DESCRIPCIO");
      tmp.prioritat = rs.getLong("PRIORITAT");
      v.add(tmp);
    }
    return v;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}


public Element findAllXml() { 
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  int k=0;
  try {
    String sql="SELECT * from co_jerarquies ";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    Element queryResult = new Element("query-result");
    while (rs.next()) {
      JerarquiesSkel tmp=new JerarquiesSkel();
      tmp.idJerarquia = rs.getString("ID_JERARQUIA");
      tmp.codiJerarquia = rs.getString("CODI_JERARQUIA");
      tmp.descripcio = rs.getString("DESCRIPCIO");
      tmp.prioritat = rs.getLong("PRIORITAT");
      Element tmpElem = tmp.toXml();
      tmpElem.setAttribute("rowid",""+k);
      queryResult.addChild(tmpElem);
      k++;
    }
    return queryResult;
  } catch (Exception e) {
    throw new BaseRuntimeException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}


}
