//Generation Date: Wed Nov 21 15:53:29 CET 2007
package com.termcat.bd.beans.skels;

import java.sql.*;
import java.io.*;
import java.util.Vector;
import java.util.List;
import com.termcat.bd.utils.DBConnect;
import com.termcat.bd.exceptions.*;
import electric.xml.*;

import java.util.*;
import java.text.*;

/**
  * MarquesPSkel
  * Clase para acceder a BD
  * DBTable: co_marques_p
  * @author collazos
  * -----------------------------------------
  * Database version : 1.0 (2007-04-29)
  * Driver Name : H2 JDBC Driver
  * Driver Version : 1.0
  * Generator version : 2.2.0
  * Generation Date : Wed Nov 21 15:53:29 CET 2007
  * @todo extends this class always !!!
  * 
  */
public class MarquesPSkel implements Serializable, Comparable {
  public final static String TABLE_NAME = "co_marques_p"; // (Alias from: co_marques_p)
  private boolean dirty = false;
  private boolean valid = true;
  public static int numFields = 3;

  /**
   * Random Generated UID for this serializable class
   * <code>serialVersionUID</code>
   */
  private static final long serialVersionUID =-2980307627176139344L;

  public static final long NULL_LONG =9223372036854775807L;
  public static final double NULL_DOUBLE =1.7976931348623157E308;
  public static final int NULL_INT =2147483647;
  public static final short NULL_SHORT =32767;
  public static final float NULL_FLOAT =3.4028235E38f;

  /**
   * Dirty flags for all fields
   */
 private boolean[] dirtyFields = {false,false,false};
 private final boolean[] dirtyFieldsDefault = {false,false,false};

  public MarquesPSkel(String idMarca,String codiMarca_p,String descripcio) {
    this.idMarca = idMarca;
    this.codiMarca_p = codiMarca_p;
    this.descripcio = descripcio;
  }

  public MarquesPSkel(String idMarca) {
    this.idMarca = idMarca;
  }

  public MarquesPSkel() { 
  }

  /**
    * Type : VARCHAR Name : ID_MARCA
    */
    private String idMarca;

  /**
    * Type : VARCHAR Name : CODI_MARCA_P
    */
    private String codiMarca_p;

  /**
    * Type : VARCHAR Name : DESCRIPCIO
    */
    private String descripcio;

  /**
    * Sets the value for idMarca
    * @param idMarca
    */
  public void setIdMarca(String idMarca) {
    if (idMarca.length() > 64)
      this.idMarca=idMarca.substring(0,64);
    else this.idMarca=idMarca;
    this.dirty = true;
    dirtyFields[0] = true;
  }

  /**
    * Gets the value for idMarca
    */
  public String getIdMarca() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idMarca;
  }

  /**
    * Sets the value for codiMarca_p
    * @param codiMarca_p
    */
  public void setCodiMarca_p(String codiMarca_p) {
    if (codiMarca_p.length() > 10)
      this.codiMarca_p=codiMarca_p.substring(0,10);
    else this.codiMarca_p=codiMarca_p;
    this.dirty = true;
    dirtyFields[1] = true;
  }

  /**
    * Gets the value for codiMarca_p
    */
  public String getCodiMarca_p() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return codiMarca_p;
  }

  /**
    * Sets the value for descripcio
    * @param descripcio
    */
  public void setDescripcio(String descripcio) {
    if (descripcio.length() > 100)
      this.descripcio=descripcio.substring(0,100);
    else this.descripcio=descripcio;
    this.dirty = true;
    dirtyFields[2] = true;
  }

  /**
    * Gets the value for descripcio
    */
  public String getDescripcio() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return descripcio;
  }

/**
  * Return a boolean if the element with PK exists.
  */
public boolean exists(String idMarca)  {
  boolean exists = false;
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  try {
    String sql="SELECT * FROM CO_MARQUES_P" +" where ID_MARCA="+formatString(idMarca);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    if (rs.next()) {
      exists = true;
    }
  } catch (Exception e) {
    exists = false;
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
  return exists;
}

/**
  * Inserts to the database for table "co_marques_p"
  */
public void create(Connection con) throws CreateException {
  Statement stm = null;
  try {
    String sql="INSERT INTO co_marques_p (ID_MARCA,CODI_MARCA_P,DESCRIPCIO) VALUES ("+formatString(idMarca)+","+formatString(codiMarca_p)+","+formatString(descripcio)+")";
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new CreateException("Error inserting row");
  } catch (Exception e) {
    throw new CreateException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Inserts to the database for table "co_marques_p"
  */
public void create() throws CreateException {
  Connection con = null;
  Statement stm = null;
  try {
    String sql="INSERT INTO co_marques_p (ID_MARCA,CODI_MARCA_P,DESCRIPCIO) VALUES ("+formatString(idMarca)+","+formatString(codiMarca_p)+","+formatString(descripcio)+")";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new CreateException("Error inserting row");
  } catch (Exception e) {
    throw new CreateException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Updates the current object values into the database.
  */
protected void store(Connection con) throws StoreException {
  if (!dirty)
    return;
  if (!isGlobalDirty())
    return;
  Statement stm = null;
  try {
    String sql="UPDATE co_marques_p set ";
    int idx = 0;
    if (dirtyFields[idx++]) {
      sql+="ID_MARCA="+formatString(idMarca)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="CODI_MARCA_P="+formatString(codiMarca_p)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="DESCRIPCIO="+formatString(descripcio)+",";
    }
    sql=sql.substring(0,sql.length()-1);
    sql=sql+" where ID_MARCA="+formatString(idMarca);
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1) {
      throw new StoreException("Error updating row");
    }
    dirty = false;
    valid = true;
    dirtyFields = dirtyFieldsDefault;
  } catch (Exception e) {
  throw new StoreException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Updates the current object values into the database.
  */
protected void store() throws StoreException {
  if (!dirty)
    return;
  if (!isGlobalDirty())
    return;
  Connection con = null;
  Statement stm = null;
  try {
    String sql="UPDATE co_marques_p set ";
    int idx = 0;
    if (dirtyFields[idx++]) {
      sql+="ID_MARCA="+formatString(idMarca)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="CODI_MARCA_P="+formatString(codiMarca_p)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="DESCRIPCIO="+formatString(descripcio)+",";
    }
    sql=sql.substring(0,sql.length()-1);
    sql=sql+" where ID_MARCA="+formatString(idMarca);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1) {
      throw new StoreException("Error updating row");
    }
    dirty = false;
    valid = true;
    dirtyFields = dirtyFieldsDefault;
  } catch (Exception e) {
  throw new StoreException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Deletes from the database for table "co_marques_p"
  */
public void remove(Connection con) throws RemoveException {
  Statement stm = null;
  try {
    String sql="DELETE FROM co_marques_p WHERE ID_MARCA="+formatString(idMarca);
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new RemoveException("Error deleting row");
  } catch (Exception e) {
    throw new RemoveException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Deletes from the database for table "co_marques_p"
  */
public void remove() throws RemoveException {
  Connection con = null;
  Statement stm = null;
  try {
    String sql="DELETE FROM co_marques_p WHERE ID_MARCA="+formatString(idMarca);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new RemoveException("Error deleting row");
  } catch (Exception e) {
    throw new RemoveException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

public int compareTo(Object o) {
  MarquesPSkel cn = (MarquesPSkel) o;
  int result = 0;
  result = this.idMarca.compareTo(cn.idMarca);
  if (result != 0) { return result; };
  result = this.codiMarca_p.compareTo(cn.codiMarca_p);
  if (result != 0) { return result; };
  result = this.descripcio.compareTo(cn.descripcio);
  if (result != 0) { return result; };
  return result;
}
/**
  * Finds and return the object of this PK.
  */
public MarquesPSkel findByPrimaryKey(String idMarca) throws FinderException {
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  try {
    String sql="SELECT * FROM CO_MARQUES_P" +" where ID_MARCA="+formatString(idMarca);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    if (!rs.next()) {
      throw new FinderException("Primary Key not found");
    }
    this.idMarca = rs.getString("ID_MARCA");
    this.codiMarca_p = rs.getString("CODI_MARCA_P");
    this.descripcio = rs.getString("DESCRIPCIO");
    return this;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Finds and return a List for a generic where.
  */
public List findByGenericWhere(String where) throws FinderException {
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  List result = new ArrayList();
  try {
    String sql="SELECT * FROM CO_MARQUES_P" +" WHERE "+where;
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    while (rs.next()) {
      MarquesPSkel tmp = (MarquesPSkel) this.getClass().newInstance();
      tmp.idMarca = rs.getString("ID_MARCA");
      tmp.codiMarca_p = rs.getString("CODI_MARCA_P");
      tmp.descripcio = rs.getString("DESCRIPCIO");
      result.add(tmp);
    }
    return result;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

  protected void load() throws LoadException {
  if (valid)
    return;
  try {
    MarquesPSkel cn = findByPrimaryKey(idMarca);
  cn.setValid(true);
    this.idMarca = cn.getIdMarca();
    this.codiMarca_p = cn.getCodiMarca_p();
    this.descripcio = cn.getDescripcio();
    dirty = false;
    valid = true;
  } catch (FinderException e) {
     throw new LoadException(e.toString());
  }
}

/**
  * Synchronize the current object values into the database.
  */
public void flush() throws Exception{
  try {
    if (dirty) {
      store();
      dirty = false;
    }
  } catch (Exception e) {
    e.printStackTrace();
  throw e;
  }
}
/**
  * Synchronize the current object values into the database.
  */
public void flush(Connection con) throws Exception{
  try {
    if (dirty) {
      store(con);
      dirty = false;
    }
  } catch (Exception e) {
    e.printStackTrace();
  throw e;
  }
}

  public static String formatString(String st) {
    String stString = "null";
    if (st != null) {
      if (st.indexOf("'") != -1)
        st = BdUtils.replaceString(st,"'","''");
      stString = "'"+st+"'";
    }
    return stString;
  }

  public static String formatTimeStamp(Timestamp ts)  {
    String tsString = "null";
    if (ts!=null) {
        tsString = "'"+ts.toString()+"'";
    }
    return tsString;
  }

  public static String formatInteger(int i) {
    if (i == NULL_INT)
      return "NULL";
    else
      return ""+i;
  }

  public static String formatDouble(double d) {
    if (d == NULL_DOUBLE)
      return "NULL";
    else
      return ""+d;
  }

  public static String formatLong(long l) {
    if (l == NULL_LONG)
      return "NULL";
    else
      return ""+l;
  }

  public static String formatShort(double s) {
    if (s == NULL_SHORT)
      return "NULL";
    else
      return ""+s;
  }

  public static String formatFloat(float f) {
    if (f == NULL_FLOAT)
      return "NULL";
    else
      return ""+f;
  }

  public static String formatDate(java.util.Date d)  {
    String tsString = "null";
    if (d!=null) {
        tsString = "'"+d.toString()+"'";
    }
    return tsString;
  }

  public String toString() {
    String result = "\n";
    result+="idMarca: "+idMarca+"\n";
    result+="codiMarca_p: "+codiMarca_p+"\n";
    result+="descripcio: "+descripcio+"\n";
    return result;
  }


  public Element toXml() {
    Document doc = new Document();
    Element main = doc.addElement("MarquesP");
    Element elem_1= doc.addElement("idMarca");
    elem_1.setText(""+(this.getIdMarca() == null || this.getIdMarca().equals("null")?"":this.getIdMarca()));
    main.addChild(elem_1);
    Element elem_2= doc.addElement("codiMarca_p");
    elem_2.setText(""+(this.getCodiMarca_p() == null || this.getCodiMarca_p().equals("null")?"":this.getCodiMarca_p()));
    main.addChild(elem_2);
    Element elem_3= doc.addElement("descripcio");
    elem_3.setText(""+(this.getDescripcio() == null || this.getDescripcio().equals("null")?"":this.getDescripcio()));
    main.addChild(elem_3);
    doc.addChild(main);
    return doc.getRoot();

  }


  public boolean isDirty() {
    return this.dirty;
  }

  public boolean isValid() {
    return this.valid;
  }

  public void setDirty(boolean dirty) {
    this.dirty = dirty;
    if (this.dirty == false) dirtyFields = dirtyFieldsDefault;
  }

  public void setValid(boolean valid) {
    this.valid = valid;
  }
  public boolean isGlobalDirty(){
  boolean result = false;
  for (int i=0;i<numFields;i++)
    result=result || dirtyFields[i];
  return result;
  }

public Vector findAll() throws FinderException { 
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  Vector v = new Vector();
  try {
    String sql="SELECT * from co_marques_p ";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    while (rs.next()) {
      MarquesPSkel tmp=(MarquesPSkel) this.getClass().newInstance();
      tmp.idMarca = rs.getString("ID_MARCA");
      tmp.codiMarca_p = rs.getString("CODI_MARCA_P");
      tmp.descripcio = rs.getString("DESCRIPCIO");
      v.add(tmp);
    }
    return v;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}


public Element findAllXml() { 
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  int k=0;
  try {
    String sql="SELECT * from co_marques_p ";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    Element queryResult = new Element("query-result");
    while (rs.next()) {
      MarquesPSkel tmp=new MarquesPSkel();
      tmp.idMarca = rs.getString("ID_MARCA");
      tmp.codiMarca_p = rs.getString("CODI_MARCA_P");
      tmp.descripcio = rs.getString("DESCRIPCIO");
      Element tmpElem = tmp.toXml();
      tmpElem.setAttribute("rowid",""+k);
      queryResult.addChild(tmpElem);
      k++;
    }
    return queryResult;
  } catch (Exception e) {
    throw new BaseRuntimeException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}


}
