//Generation Date: Wed Nov 21 15:53:30 CET 2007
package com.termcat.bd.beans.skels;

import java.sql.*;
import java.io.*;
import java.util.Vector;
import java.util.List;
import com.termcat.bd.utils.DBConnect;
import com.termcat.bd.exceptions.*;
import electric.xml.*;

import java.util.*;
import java.text.*;

/**
  * NotesSkel
  * Clase para acceder a BD
  * DBTable: co_notes
  * @author collazos
  * -----------------------------------------
  * Database version : 1.0 (2007-04-29)
  * Driver Name : H2 JDBC Driver
  * Driver Version : 1.0
  * Generator version : 2.2.0
  * Generation Date : Wed Nov 21 15:53:30 CET 2007
  * @todo extends this class always !!!
  * 
  */
public class NotesSkel implements Serializable, Comparable {
  public final static String TABLE_NAME = "co_notes"; // (Alias from: co_notes)
  private boolean dirty = false;
  private boolean valid = true;
  public static int numFields = 6;

  /**
   * Random Generated UID for this serializable class
   * <code>serialVersionUID</code>
   */
  private static final long serialVersionUID =3240202945557943313L;

  public static final long NULL_LONG =9223372036854775807L;
  public static final double NULL_DOUBLE =1.7976931348623157E308;
  public static final int NULL_INT =2147483647;
  public static final short NULL_SHORT =32767;
  public static final float NULL_FLOAT =3.4028235E38f;

  /**
   * Dirty flags for all fields
   */
 private boolean[] dirtyFields = {false,false,false,false,false,false};
 private final boolean[] dirtyFieldsDefault = {false,false,false,false,false,false};

  public NotesSkel(String idNota,String idFitxa,String idDiccionari,String idLlengua,String notaRtf,String notaNormal) {
    this.idNota = idNota;
    this.idFitxa = idFitxa;
    this.idDiccionari = idDiccionari;
    this.idLlengua = idLlengua;
    this.notaRtf = notaRtf;
    this.notaNormal = notaNormal;
  }

  public NotesSkel(String idNota) {
    this.idNota = idNota;
  }

  public NotesSkel() { 
  }

  /**
    * Type : VARCHAR Name : ID_NOTA
    */
    private String idNota;

  /**
    * Type : VARCHAR Name : ID_FITXA
    */
    private String idFitxa;

  /**
    * Type : VARCHAR Name : ID_DICCIONARI
    */
    private String idDiccionari;

  /**
    * Type : VARCHAR Name : ID_LLENGUA
    */
    private String idLlengua;

  /**
    * Type : VARCHAR Name : NOTA_RTF
    */
    private String notaRtf;

  /**
    * Type : VARCHAR Name : NOTA_NORMAL
    */
    private String notaNormal;

  /**
    * Sets the value for idNota
    * @param idNota
    */
  public void setIdNota(String idNota) {
    if (idNota.length() > 64)
      this.idNota=idNota.substring(0,64);
    else this.idNota=idNota;
    this.dirty = true;
    dirtyFields[0] = true;
  }

  /**
    * Gets the value for idNota
    */
  public String getIdNota() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idNota;
  }

  /**
    * Sets the value for idFitxa
    * @param idFitxa
    */
  public void setIdFitxa(String idFitxa) {
    if (idFitxa.length() > 64)
      this.idFitxa=idFitxa.substring(0,64);
    else this.idFitxa=idFitxa;
    this.dirty = true;
    dirtyFields[1] = true;
  }

  /**
    * Gets the value for idFitxa
    */
  public String getIdFitxa() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idFitxa;
  }

  /**
    * Sets the value for idDiccionari
    * @param idDiccionari
    */
  public void setIdDiccionari(String idDiccionari) {
    if (idDiccionari.length() > 64)
      this.idDiccionari=idDiccionari.substring(0,64);
    else this.idDiccionari=idDiccionari;
    this.dirty = true;
    dirtyFields[2] = true;
  }

  /**
    * Gets the value for idDiccionari
    */
  public String getIdDiccionari() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idDiccionari;
  }

  /**
    * Sets the value for idLlengua
    * @param idLlengua
    */
  public void setIdLlengua(String idLlengua) {
    if (idLlengua.length() > 64)
      this.idLlengua=idLlengua.substring(0,64);
    else this.idLlengua=idLlengua;
    this.dirty = true;
    dirtyFields[3] = true;
  }

  /**
    * Gets the value for idLlengua
    */
  public String getIdLlengua() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return idLlengua;
  }

  /**
    * Sets the value for notaRtf
    * @param notaRtf
    */
  public void setNotaRtf(String notaRtf) {
    if (notaRtf.length() > 2000)
      this.notaRtf=notaRtf.substring(0,2000);
    else this.notaRtf=notaRtf;
    this.dirty = true;
    dirtyFields[4] = true;
  }

  /**
    * Gets the value for notaRtf
    */
  public String getNotaRtf() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return notaRtf;
  }

  /**
    * Sets the value for notaNormal
    * @param notaNormal
    */
  public void setNotaNormal(String notaNormal) {
    if (notaNormal.length() > 2000)
      this.notaNormal=notaNormal.substring(0,2000);
    else this.notaNormal=notaNormal;
    this.dirty = true;
    dirtyFields[5] = true;
  }

  /**
    * Gets the value for notaNormal
    */
  public String getNotaNormal() {
    if (!valid)
     try { load(); valid=true;}
     catch (LoadException e) {
       throw new BaseRuntimeException("Program error");
     }
    return notaNormal;
  }

/**
  * Return a boolean if the element with PK exists.
  */
public boolean exists(String idNota)  {
  boolean exists = false;
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  try {
    String sql="SELECT * FROM CO_NOTES" +" where ID_NOTA="+formatString(idNota);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    if (rs.next()) {
      exists = true;
    }
  } catch (Exception e) {
    exists = false;
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
  return exists;
}

/**
  * Inserts to the database for table "co_notes"
  */
public void create(Connection con) throws CreateException {
  Statement stm = null;
  try {
    String sql="INSERT INTO co_notes (ID_NOTA,ID_FITXA,ID_DICCIONARI,ID_LLENGUA,NOTA_RTF,NOTA_NORMAL) VALUES ("+formatString(idNota)+","+formatString(idFitxa)+","+formatString(idDiccionari)+","+formatString(idLlengua)+","+formatString(notaRtf)+","+formatString(notaNormal)+")";
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new CreateException("Error inserting row");
  } catch (Exception e) {
    throw new CreateException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Inserts to the database for table "co_notes"
  */
public void create() throws CreateException {
  Connection con = null;
  Statement stm = null;
  try {
    String sql="INSERT INTO co_notes (ID_NOTA,ID_FITXA,ID_DICCIONARI,ID_LLENGUA,NOTA_RTF,NOTA_NORMAL) VALUES ("+formatString(idNota)+","+formatString(idFitxa)+","+formatString(idDiccionari)+","+formatString(idLlengua)+","+formatString(notaRtf)+","+formatString(notaNormal)+")";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new CreateException("Error inserting row");
  } catch (Exception e) {
    throw new CreateException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Updates the current object values into the database.
  */
protected void store(Connection con) throws StoreException {
  if (!dirty)
    return;
  if (!isGlobalDirty())
    return;
  Statement stm = null;
  try {
    String sql="UPDATE co_notes set ";
    int idx = 0;
    if (dirtyFields[idx++]) {
      sql+="ID_NOTA="+formatString(idNota)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_FITXA="+formatString(idFitxa)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_DICCIONARI="+formatString(idDiccionari)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_LLENGUA="+formatString(idLlengua)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="NOTA_RTF="+formatString(notaRtf)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="NOTA_NORMAL="+formatString(notaNormal)+",";
    }
    sql=sql.substring(0,sql.length()-1);
    sql=sql+" where ID_NOTA="+formatString(idNota);
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1) {
      throw new StoreException("Error updating row");
    }
    dirty = false;
    valid = true;
    dirtyFields = dirtyFieldsDefault;
  } catch (Exception e) {
  throw new StoreException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Updates the current object values into the database.
  */
protected void store() throws StoreException {
  if (!dirty)
    return;
  if (!isGlobalDirty())
    return;
  Connection con = null;
  Statement stm = null;
  try {
    String sql="UPDATE co_notes set ";
    int idx = 0;
    if (dirtyFields[idx++]) {
      sql+="ID_NOTA="+formatString(idNota)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_FITXA="+formatString(idFitxa)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_DICCIONARI="+formatString(idDiccionari)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="ID_LLENGUA="+formatString(idLlengua)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="NOTA_RTF="+formatString(notaRtf)+",";
    }
    if (dirtyFields[idx++]) {
      sql+="NOTA_NORMAL="+formatString(notaNormal)+",";
    }
    sql=sql.substring(0,sql.length()-1);
    sql=sql+" where ID_NOTA="+formatString(idNota);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1) {
      throw new StoreException("Error updating row");
    }
    dirty = false;
    valid = true;
    dirtyFields = dirtyFieldsDefault;
  } catch (Exception e) {
  throw new StoreException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Deletes from the database for table "co_notes"
  */
public void remove(Connection con) throws RemoveException {
  Statement stm = null;
  try {
    String sql="DELETE FROM co_notes WHERE ID_NOTA="+formatString(idNota);
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new RemoveException("Error deleting row");
  } catch (Exception e) {
    throw new RemoveException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
  }
}

/**
  * Deletes from the database for table "co_notes"
  */
public void remove() throws RemoveException {
  Connection con = null;
  Statement stm = null;
  try {
    String sql="DELETE FROM co_notes WHERE ID_NOTA="+formatString(idNota);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    if (stm.executeUpdate(sql) != 1)
      throw new RemoveException("Error deleting row");
  } catch (Exception e) {
    throw new RemoveException(e.toString());
  } finally {
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

public int compareTo(Object o) {
  NotesSkel cn = (NotesSkel) o;
  int result = 0;
  result = this.idNota.compareTo(cn.idNota);
  if (result != 0) { return result; };
  result = this.idFitxa.compareTo(cn.idFitxa);
  if (result != 0) { return result; };
  result = this.idDiccionari.compareTo(cn.idDiccionari);
  if (result != 0) { return result; };
  result = this.idLlengua.compareTo(cn.idLlengua);
  if (result != 0) { return result; };
  result = this.notaRtf.compareTo(cn.notaRtf);
  if (result != 0) { return result; };
  result = this.notaNormal.compareTo(cn.notaNormal);
  if (result != 0) { return result; };
  return result;
}
/**
  * Finds and return the object of this PK.
  */
public NotesSkel findByPrimaryKey(String idNota) throws FinderException {
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  try {
    String sql="SELECT * FROM CO_NOTES" +" where ID_NOTA="+formatString(idNota);
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    if (!rs.next()) {
      throw new FinderException("Primary Key not found");
    }
    this.idNota = rs.getString("ID_NOTA");
    this.idFitxa = rs.getString("ID_FITXA");
    this.idDiccionari = rs.getString("ID_DICCIONARI");
    this.idLlengua = rs.getString("ID_LLENGUA");
    this.notaRtf = rs.getString("NOTA_RTF");
    this.notaNormal = rs.getString("NOTA_NORMAL");
    return this;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

/**
  * Finds and return a List for a generic where.
  */
public List findByGenericWhere(String where) throws FinderException {
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  List result = new ArrayList();
  try {
    String sql="SELECT * FROM CO_NOTES" +" WHERE "+where;
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    while (rs.next()) {
      NotesSkel tmp = (NotesSkel) this.getClass().newInstance();
      tmp.idNota = rs.getString("ID_NOTA");
      tmp.idFitxa = rs.getString("ID_FITXA");
      tmp.idDiccionari = rs.getString("ID_DICCIONARI");
      tmp.idLlengua = rs.getString("ID_LLENGUA");
      tmp.notaRtf = rs.getString("NOTA_RTF");
      tmp.notaNormal = rs.getString("NOTA_NORMAL");
      result.add(tmp);
    }
    return result;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}

  protected void load() throws LoadException {
  if (valid)
    return;
  try {
    NotesSkel cn = findByPrimaryKey(idNota);
  cn.setValid(true);
    this.idNota = cn.getIdNota();
    this.idFitxa = cn.getIdFitxa();
    this.idDiccionari = cn.getIdDiccionari();
    this.idLlengua = cn.getIdLlengua();
    this.notaRtf = cn.getNotaRtf();
    this.notaNormal = cn.getNotaNormal();
    dirty = false;
    valid = true;
  } catch (FinderException e) {
     throw new LoadException(e.toString());
  }
}

/**
  * Synchronize the current object values into the database.
  */
public void flush() throws Exception{
  try {
    if (dirty) {
      store();
      dirty = false;
    }
  } catch (Exception e) {
    e.printStackTrace();
  throw e;
  }
}
/**
  * Synchronize the current object values into the database.
  */
public void flush(Connection con) throws Exception{
  try {
    if (dirty) {
      store(con);
      dirty = false;
    }
  } catch (Exception e) {
    e.printStackTrace();
  throw e;
  }
}

  public static String formatString(String st) {
    String stString = "null";
    if (st != null) {
      if (st.indexOf("'") != -1)
        st = BdUtils.replaceString(st,"'","''");
      stString = "'"+st+"'";
    }
    return stString;
  }

  public static String formatTimeStamp(Timestamp ts)  {
    String tsString = "null";
    if (ts!=null) {
        tsString = "'"+ts.toString()+"'";
    }
    return tsString;
  }

  public static String formatInteger(int i) {
    if (i == NULL_INT)
      return "NULL";
    else
      return ""+i;
  }

  public static String formatDouble(double d) {
    if (d == NULL_DOUBLE)
      return "NULL";
    else
      return ""+d;
  }

  public static String formatLong(long l) {
    if (l == NULL_LONG)
      return "NULL";
    else
      return ""+l;
  }

  public static String formatShort(double s) {
    if (s == NULL_SHORT)
      return "NULL";
    else
      return ""+s;
  }

  public static String formatFloat(float f) {
    if (f == NULL_FLOAT)
      return "NULL";
    else
      return ""+f;
  }

  public static String formatDate(java.util.Date d)  {
    String tsString = "null";
    if (d!=null) {
        tsString = "'"+d.toString()+"'";
    }
    return tsString;
  }

  public String toString() {
    String result = "\n";
    result+="idNota: "+idNota+"\n";
    result+="idFitxa: "+idFitxa+"\n";
    result+="idDiccionari: "+idDiccionari+"\n";
    result+="idLlengua: "+idLlengua+"\n";
    result+="notaRtf: "+notaRtf+"\n";
    result+="notaNormal: "+notaNormal+"\n";
    return result;
  }


  public Element toXml() {
    Document doc = new Document();
    Element main = doc.addElement("Notes");
    Element elem_1= doc.addElement("idNota");
    elem_1.setText(""+(this.getIdNota() == null || this.getIdNota().equals("null")?"":this.getIdNota()));
    main.addChild(elem_1);
    Element elem_2= doc.addElement("idFitxa");
    elem_2.setText(""+(this.getIdFitxa() == null || this.getIdFitxa().equals("null")?"":this.getIdFitxa()));
    main.addChild(elem_2);
    Element elem_3= doc.addElement("idDiccionari");
    elem_3.setText(""+(this.getIdDiccionari() == null || this.getIdDiccionari().equals("null")?"":this.getIdDiccionari()));
    main.addChild(elem_3);
    Element elem_4= doc.addElement("idLlengua");
    elem_4.setText(""+(this.getIdLlengua() == null || this.getIdLlengua().equals("null")?"":this.getIdLlengua()));
    main.addChild(elem_4);
    Element elem_5= doc.addElement("notaRtf");
    elem_5.setText(""+(this.getNotaRtf() == null || this.getNotaRtf().equals("null")?"":this.getNotaRtf()));
    main.addChild(elem_5);
    Element elem_6= doc.addElement("notaNormal");
    elem_6.setText(""+(this.getNotaNormal() == null || this.getNotaNormal().equals("null")?"":this.getNotaNormal()));
    main.addChild(elem_6);
    doc.addChild(main);
    return doc.getRoot();

  }


  public boolean isDirty() {
    return this.dirty;
  }

  public boolean isValid() {
    return this.valid;
  }

  public void setDirty(boolean dirty) {
    this.dirty = dirty;
    if (this.dirty == false) dirtyFields = dirtyFieldsDefault;
  }

  public void setValid(boolean valid) {
    this.valid = valid;
  }
  public boolean isGlobalDirty(){
  boolean result = false;
  for (int i=0;i<numFields;i++)
    result=result || dirtyFields[i];
  return result;
  }

public Vector findAll() throws FinderException { 
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  Vector v = new Vector();
  try {
    String sql="SELECT * from co_notes ";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    while (rs.next()) {
      NotesSkel tmp=(NotesSkel) this.getClass().newInstance();
      tmp.idNota = rs.getString("ID_NOTA");
      tmp.idFitxa = rs.getString("ID_FITXA");
      tmp.idDiccionari = rs.getString("ID_DICCIONARI");
      tmp.idLlengua = rs.getString("ID_LLENGUA");
      tmp.notaRtf = rs.getString("NOTA_RTF");
      tmp.notaNormal = rs.getString("NOTA_NORMAL");
      v.add(tmp);
    }
    return v;
  } catch (Exception e) {
    throw new FinderException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}


public Element findAllXml() { 
  Connection con = null;
  Statement stm = null;
  ResultSet rs = null;
  int k=0;
  try {
    String sql="SELECT * from co_notes ";
    con = DBConnect.getConnection();
    stm = con.createStatement();
    rs = stm.executeQuery(sql);
    Element queryResult = new Element("query-result");
    while (rs.next()) {
      NotesSkel tmp=new NotesSkel();
      tmp.idNota = rs.getString("ID_NOTA");
      tmp.idFitxa = rs.getString("ID_FITXA");
      tmp.idDiccionari = rs.getString("ID_DICCIONARI");
      tmp.idLlengua = rs.getString("ID_LLENGUA");
      tmp.notaRtf = rs.getString("NOTA_RTF");
      tmp.notaNormal = rs.getString("NOTA_NORMAL");
      Element tmpElem = tmp.toXml();
      tmpElem.setAttribute("rowid",""+k);
      queryResult.addChild(tmpElem);
      k++;
    }
    return queryResult;
  } catch (Exception e) {
    throw new BaseRuntimeException(e.toString());
  } finally {
    if (rs != null) try { rs.close(); } catch (Exception ignored) {}
    if (stm != null) try { stm.close(); } catch (Exception ignored) {}
    if (con != null) DBConnect.putConnection(con);
  }
}


}
