/*
 * BdRestore.java
 *
 * Created on 25 de julio de 2007, 11:56
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.bd.utils;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStreamWriter;
import org.h2.tools.RunScript;



/**
 *
 * @author Vazquezl
 */
public class BdRestore {
    
    private static String SCRIP_FILE_NAME = "aplicacioTerm.sql";
    private static String ENCODING = "UTF-8";    
    
    /**
     * Creates a new instance of BdRestore
     */
    public BdRestore() {
    }
    
    public boolean generateBdFromScript(){
        boolean allOk= false;
        String url = DBConnect.DB_URL;
        String user = DBConnect.DB_USER;
        String password = DBConnect.DB_PASS;
        String script= System.getProperty("user.home")+"/"+SCRIP_FILE_NAME;
        if(umpackFile(SCRIP_FILE_NAME)){
            try{
                RunScript.execute(url, user, password, script,ENCODING,true);
                System.out.println("Database created!!");
                allOk= true;
            }
            catch(Exception e){
                System.out.print("Error ejecutando el scrip de base de datos" );
                e.printStackTrace();
            }
        }
        return allOk;
    }
    
    private boolean umpackFile(String resourceName){
        boolean isOk = true;
        try{
            InputStream in = getClass().getResourceAsStream(resourceName);
            OutputStreamWriter out = new OutputStreamWriter(new FileOutputStream(System.getProperty("user.home")+"/"+resourceName),"UTF-8");
            int num_read =0;

            byte[] buf = new byte[1024];
            while((num_read = in.read(buf, 0, buf.length)) > 0){
                 String str = new String(buf,0,num_read,ENCODING);
                 if(num_read>0){
                     out.write(str);
                 }
            }
            out.flush();
            out.close();
        }    
        catch(Exception e){
            isOk = false;
            System.out.print("Error al obtener el fichero "+resourceName+" como recurso" );
            e.printStackTrace();
        }    
        return isOk;        
    }
    
    public static void main (String args[]){
        new BdRestore().generateBdFromScript();
    }
}
