/*
 * HelpLauncher.java
 *
 * Created on 27 de julio de 2007, 11:51
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.layout.ajuda;

import com.termcat.layout.MainFrame;
import com.termcat.util.literales.Literales;

import javax.help.*;
import java.util.*;
import java.net.*;
import javax.swing.*;
import java.awt.event.ActionEvent;
import javax.jnlp.DownloadService;
import javax.jnlp.DownloadServiceListener;
import javax.jnlp.ServiceManager;
import javax.jnlp.UnavailableServiceException;


/**
 *
 * @author VazquezL
 */
public class HelpLauncher {
    
    static private DownloadService _ds = null; 
    
    static public final String helpsetName = java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Gdt.hs");
    
    static public HelpBroker _hb = null;
    
    /** Creates a new instance of HelpLauncher */
    public HelpLauncher() {
        
    }

     public void  showHelp(final ActionEvent evt) {
	new Thread() {
	    public void run() {
		showHelpHelper(evt);
	    }
	}.start();
    }

    private void showHelpHelper(ActionEvent evt) {
	initializeHelpSystem();
	new CSH.DisplayHelpFromSource(_hb).actionPerformed(evt);
    }
     private synchronized void initializeHelpSystem() {
                 
	if (_hb != null) return;
	try {
	    JOptionPane pane = new JOptionPane(Literales.getTextForMessage(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Ayuda_CargandoAyuda")),JOptionPane.INFORMATION_MESSAGE);
	    JDialog dialog = pane.createDialog(null, Literales.getTextForMessage(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Ayuda_Titulo")));
	    dialog.setModal(false);
	    dialog.setVisible(true);
	    
	    HelpSet hs = null;
	    ClassLoader cl = MainFrame.class.getClassLoader();
	    URL hsURL = HelpSet.findHelpSet(cl, helpsetName);
	    hs = new HelpSet(cl, hsURL);
	    _hb = hs.createHelpBroker();
	    _hb.initPresentation();
	    dialog.setVisible(false);
	} catch (Exception ee) {
	    System.out.println(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("HelpSet_") + helpsetName + java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("_not_found"));
	    return;
	}
    }
   
     
    /**
     *@deprecated
     **/ 
    private void checkForDownload() {
	try {
	     _ds = (DownloadService)ServiceManager.lookup(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("javax.jnlp.DownloadService"));
        } catch (UnavailableServiceException e) {
          _ds = null;

        }

        if (_ds != null) {
        try {
	    
           if (_ds.isPartCached(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("help"))) {
		System.out.println(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Help_System_is_cached"));
		return;
	    }
	    _ds.loadPart(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("help"), _ds.getDefaultProgressWindow());
	  } catch(Exception e) {
            e.printStackTrace();
	  }
        } 
  }
    
    
}
