/*
 * FixedLengthPlainDocumen.java
 *
 * Created on 13 de julio de 2007, 11:20
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.layout.commons;

import java.awt.Toolkit;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.PlainDocument;

/**
 *
 * @author Vazquezl
 */
 public class FixedLengthPlainDocument extends PlainDocument{ 
	                
    private int maxLength; 
	                 
    public FixedLengthPlainDocument(int maxLength){
        this.maxLength = maxLength; 
    } 
    
    public void insertString(int offset, String str,AttributeSet a) throws BadLocationException { 
        if(getLength() + str.length() > maxLength) {
           Toolkit.getDefaultToolkit().beep(); 
        } 
        else { 
           super.insertString(offset, str, a);

        } 
    }                
   } 
	        
