/*
 * MousePopupListener.java
 *
 * Created on 17 de julio de 2007, 10:18
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.layout.commons.popup;

import com.termcat.layout.commons.*;
import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
/**
 *
 * @author Mena
 */
public class MousePopupListener extends MouseAdapter 
{
       PopupMenuTable popup;
    
        public MousePopupListener(PopupMenuTable popup)
        {
            this.popup=popup;
        }
                
        public void mousePressed(MouseEvent e) { checkPopup(e); }
        public void mouseClicked(MouseEvent e) { checkPopup(e); }
        public void mouseReleased(MouseEvent e) { checkPopup(e); }

        private void checkPopup(MouseEvent e) 
        {                    
            // Cas en que s'ha clicat el bot dret.   
            if (e.isPopupTrigger( )) 
            {
                // Obtenim la taula que ha generat l'event i marquem la fila seleccionada.
                JTable table = (JTable)e.getSource();
                int row = table.rowAtPoint( e.getPoint() );
                int column = table.columnAtPoint( e.getPoint() );
                table.changeSelection(row, column, false, false);
   
                // Mostrem el popup amb el men.
                this.popup.show(table, e.getX( ), e.getY( ));                
            }
        }
    
}
