/*
 * SuperscriptAction.java
 *
 * Created on 18 de octubre de 2007, 9:52
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.layout.commons.rtf;

import java.awt.event.ActionEvent;
import javax.swing.JEditorPane;
import javax.swing.text.MutableAttributeSet;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledEditorKit;
/**
 *
 * @author Mena
 */
public class SuperscriptAction extends StyledEditorKit.StyledTextAction
{
	
    public SuperscriptAction(){
		super(StyleConstants.Superscript.toString());
    }
    public void actionPerformed(ActionEvent ae){
	JEditorPane editor = getEditor(ae);
	if (editor != null) {
		StyledEditorKit kit = getStyledEditorKit(editor);
		MutableAttributeSet attr = kit.getInputAttributes();
		boolean superscript = (StyleConstants.isSuperscript(attr)) ? false : true;
		SimpleAttributeSet sas = new SimpleAttributeSet();
		StyleConstants.setSuperscript(sas, superscript);
		setCharacterAttributes(editor, sas, false);
	}			
    }
}
