/*
 * MouseJTreeListener.java
 *
 * Created on 27 de agosto de 2007, 18:40
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.layout.commons.tree;

import com.termcat.bd.beans.ArbreCamp;
import com.termcat.bd.exceptions.CreateException;
import com.termcat.business.areas.AreaManager;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.layout.commons.*;
import com.termcat.layout.commons.popup.PopupMenuTable;
import com.termcat.layout.terminologic.arees.AreesTematiquesAlta;
import com.termcat.layout.terminologic.fitxes.Fitxa;
import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;

/**
 *
 * @author Mena
 */
public class DoubleClickTree extends MouseAdapter 
{
       MainFrame menuFrame;
       AreesTematiquesAlta module;

       public JTable table;
       private DefaultTableModel model;
       public PopupMenuTable arbrePopupTable;
       
        public DoubleClickTree(MainFrame menuFrame, FunctionalModule module,PopupMenuTable arbrePopupTable)
        {
            this.menuFrame=menuFrame;          
            this.module=(AreesTematiquesAlta) module;
            if (arbrePopupTable!=null)
            {
                this.arbrePopupTable=arbrePopupTable;
                this.table=this.module.getTableAt();
                this.model =(DefaultTableModel)table.getModel();
            }
        }
                
        public void mousePressed(MouseEvent e) 
        {               
            if (e.getClickCount() == 2)
            {
                checkPopup(e);
             }
        }

        private void checkPopup(MouseEvent e) 
        {                    
            
            DefaultMutableTreeNode node;
            
            JTree treeClicked=(JTree)e.getSource();
            TreePath path = treeClicked.getPathForLocation(e.getX(), e.getY());
            boolean trobat=false;
            boolean error=false;
            if (path != null)
            {
                    node = (DefaultMutableTreeNode)path.getLastPathComponent();                     
                    ArbreCamp value = (ArbreCamp)node.getUserObject();
                    String nom=module.getAbsoluteAreaName(value.getIdPare(),value.getNomArea(),value.getIdArea());
                    String idArea=value.getIdArea();
                    String id=null;

                    //  En el cas que sigui el root el que es fa es un expand de la carpeta
                  //  if (value.getIdArea().equals(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("root")))
                  //  {
                  //          treeClicked.expandPath(path);
                  //  }
                  //  else
                  //  {
                            String firstId=(String)model.getValueAt(0,0);
                            try
                            {
  
                                AreaManager.getManager().altaAreaFitxa(idArea,menuFrame.getIdFitxa());
                                // Actualitzem la taula
                                 if (firstId==null || firstId.equals(""))
                                    model.removeRow(0);
        
                                model.addRow(new Object[] {idArea,nom});                               
                                arbrePopupTable.enableMenuItems();

                                // Marquem el flag de dirty a true
                                menuFrame.setCurrentFitxaDirty(true);
                    
                                // Desmarquem la opci seleccionada.
                                treeClicked.setSelectionPath(null);
                            }
                            catch(Exception exc)
                            {
                                exc.printStackTrace();
                            }
                   // }  
             }           
       }    
}