/*
 * ValorsMain.java
 *
 * Created on 21 de septiembre de 2007, 10:46
 */

package com.termcat.layout.terminologic.cerca;

import com.termcat.bd.utils.SqlUtils;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.layout.commons.lists.ItemListCustom;
import com.termcat.layout.commons.search.Values;
import com.termcat.util.literales.Literales;
import java.util.Vector;
import javax.swing.JComboBox;
import javax.swing.JOptionPane;

/**
 *
 * @author  Mena
 */
public class ValorsMain extends FunctionalModule
{
    private static ValorsMain valorsMain=null;
    
    // Referencia a l'objecte de FitxaMain, per tal de poder resoldre conflictes.
    private FitxaMain fitxaMain;
    
   /* private static synchronized ValorsMain getInstance(MainFrame menuFrame)
    {
        if(valorsMain!=null)
            return valorsMain;
        else
        {
            valorsMain=new ValorsMain(menuFrame);
            return valorsMain;
        }
    }*/
    
    public void destroy()
    {
        this.valorsMain=null;
    }
    /** Creates new form ValorsMain */
    public ValorsMain(MainFrame menuFrame) 
    {
        super(menuFrame);
        initComponents();
        
        // Inicialitzaci dels combos
        if (this.menuFrame.getCercaObject()==null)
        {
            initCombo(denominacioCombo,-1);
            initCombo(definicioCombo,-1);
            initCombo(notaCombo,-1);
        }
        else
        {           
            // En cas de fer-se la crrega d'un filtre es defineixen els conflictes a false.
            this.menuFrame.setDefinitionConflict(false);
            this.menuFrame.setNoteConflict(false);
            
            // Inicialitzaci dels combos.           
            initCombo(denominacioCombo,menuFrame.getCercaObject().getDenominacions().getType());
            initCombo(definicioCombo,menuFrame.getCercaObject().getDefinicions().getType());
            initCombo(notaCombo,menuFrame.getCercaObject().getNotes().getType());
            
            // Inicialitzaci dels valors amb el texte de la cerca.
            denominacioField.setText(menuFrame.getCercaObject().getDenominacions().getValue());
            setDefinicioField(menuFrame.getCercaObject().getDefinicions().getValue());
            setNoteField(menuFrame.getCercaObject().getNotes().getValue());
        }
        
        this.fitxaMain=null;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        denominacioField = new javax.swing.JTextField();
        denominacioCombo = new javax.swing.JComboBox();
        jPanel2 = new javax.swing.JPanel();
        definicioField = new javax.swing.JTextField();
        definicioCombo = new javax.swing.JComboBox();
        jPanel3 = new javax.swing.JPanel();
        notaField = new javax.swing.JTextField();
        notaCombo = new javax.swing.JComboBox();

        setMaximumSize(new java.awt.Dimension(805, 460));
        setMinimumSize(new java.awt.Dimension(805, 460));
        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("DenominacioLabel")));

        denominacioCombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(31, Short.MAX_VALUE)
                .add(denominacioCombo, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 140, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(95, 95, 95)
                .add(denominacioField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 290, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(123, 123, 123))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(21, 21, 21)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(denominacioField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(denominacioCombo, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(25, Short.MAX_VALUE))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("DefinicioLabel")));
        definicioField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                definitionFieldKeyPressed(evt);
            }
        });

        definicioCombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .add(27, 27, 27)
                .add(definicioCombo, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 144, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(95, 95, 95)
                .add(definicioField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 291, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(122, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(definicioField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(definicioCombo, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(36, Short.MAX_VALUE))
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("NotaLabel")));
        notaField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                noteFieldKeyPressed(evt);
            }
        });

        notaCombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        org.jdesktop.layout.GroupLayout jPanel3Layout = new org.jdesktop.layout.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3Layout.createSequentialGroup()
                .add(24, 24, 24)
                .add(notaCombo, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 147, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(94, 94, 94)
                .add(notaField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 295, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(119, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(notaField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(notaCombo, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(37, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .add(63, 63, 63)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .add(47, 47, 47))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(26, 26, 26)
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(50, 50, 50)
                .add(jPanel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(42, 42, 42)
                .add(jPanel3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(45, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void noteFieldKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_noteFieldKeyPressed
        if (this.menuFrame.getNoteConflict())
        {
            resolveNoteConflict();
        }
    }//GEN-LAST:event_noteFieldKeyPressed

    private void definitionFieldKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_definitionFieldKeyPressed
        if (this.menuFrame.getDefinitionConflict())
        {
            resolveDefinitionConflict();
        }
    }//GEN-LAST:event_definitionFieldKeyPressed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox definicioCombo;
    private javax.swing.JTextField definicioField;
    private javax.swing.JComboBox denominacioCombo;
    private javax.swing.JTextField denominacioField;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JComboBox notaCombo;
    private javax.swing.JTextField notaField;
    // End of variables declaration//GEN-END:variables

    
    // Definici de constants.
    private final String IGUAL=Literales.getTextForLiteral("Cerca_Igual");
    private final String CONTE=Literales.getTextForLiteral("Cerca_Conte");
    private final String COMENCA=Literales.getTextForLiteral("Cerca_Begin");
    private final String ACABA=Literales.getTextForLiteral("Cerca_Ends");
    
    // Mtode d'inicialitzaci d'una combo
    private void initCombo(JComboBox combo, int i) 
    {              
            Values igual=new Values(0,IGUAL);
            Values conte=new Values(1,CONTE);
            Values comenca=new Values(2,COMENCA);
            Values acaba=new Values(3,ACABA);
            
            Vector v=new Vector();
            v.add(igual);
            v.add(conte);
            v.add(comenca);
            v.add(acaba);
            
            combo.setModel(new javax.swing.DefaultComboBoxModel(v));
            
            // En cas que hi hagi una cerca activa inicialitzem els combos amb els valors.
            if (i>0)
                combo.setSelectedIndex(i);
     }

    // Getters    
    public Values getDenominacionsCerca()
    {
        Values value=new Values();
        value.setType(((Values)denominacioCombo.getSelectedItem()).getType());
        value.setValue(SqlUtils.escapeSingleQuote(denominacioField.getText()));
        return value;
    }
    
     public Values getDefinicionsCerca()
    {
        Values value=new Values();
        value.setType(((Values)definicioCombo.getSelectedItem()).getType());
        value.setValue(SqlUtils.escapeSingleQuote(definicioField.getText()));
        return value;
    }

    public Values getNotesCerca()
    {
        Values value=new Values();
        value.setType(((Values)notaCombo.getSelectedItem()).getType());
        value.setValue(SqlUtils.escapeSingleQuote(notaField.getText()));
        return value;
    }
    
    // Setters
    public void setDefinicioField(String text)
    {
        definicioField.setText(text);
    }

    public void setNoteField(String text) 
    {
        notaField.setText(text);
    }

    public void setFitxaMain(FitxaMain fitxaMain) 
    {
        this.fitxaMain=fitxaMain;        
    }

    // Mtodes de resoluci de conflictes entre les definicions i notes de les pestanyes de ValorsMain i FItxaMain.
    // Definicions
    private void resolveDefinitionConflict() 
    {
        int response = JOptionPane.showConfirmDialog(menuFrame, Literales.getTextForMessage("CercaConflicteDefinicio"), "", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
        if (response == JOptionPane.YES_OPTION) 
        {
            // En cas de mantenir els canvis hem de fer que en la pestanya de fitxa el criteri seleccionat sigui: 'Totes Notes'            
            fitxaMain.getTotesDefinitionsRadioButton().setSelected(true);            
            this.menuFrame.setDefinitionConflict(false);            
        }
        else if (response == JOptionPane.NO_OPTION)
        {
            // En cas de no mantenir els canvis, esborrem el text del camp definicions.
            setDefinicioField("");            
        }
    }
    
    // Notes
    private void resolveNoteConflict() 
    {
        int response = JOptionPane.showConfirmDialog(menuFrame,Literales.getTextForMessage("CercaConflicteNota"), "", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
        if (response == JOptionPane.YES_OPTION) 
        {
            // En cas de mantenir els canvis hem de fer que en la pestanya de fitxa el criteri seleccionat sigui: 'Totes Definicions'
            fitxaMain.getTotesNotesRadioButton().setSelected(true);
            this.menuFrame.setNoteConflict(false);                  
        }
        else if (response == JOptionPane.NO_OPTION)
        {
            // En cas de no mantenir els canvis, esborrem el text del camp definicions.
            setNoteField("");
        } 
    }

}