/*
 * Literales.java
 *
 * Created on 23 de julio de 2007, 10:58
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.util.literales;

 import java.util.ResourceBundle;
 import java.text.MessageFormat;

/**
 *
 * @author Vazquezl
 */
public class Literales {
 
 private static final String BUNDLE_MESSAGES_NAME = "com/termcat/util/literales/Mensajes";
 private static final String BUNDLE_LITERALES_NAME = "com/termcat/util/literales/Literales";
 
 public static String getTextForMessage(String messageKey){
     String value="["+messageKey+"]";
     try{
       value = ResourceBundle.getBundle(BUNDLE_MESSAGES_NAME).getString(messageKey);
     }
     catch(Exception e){
         e.printStackTrace();
     }
     return value;
 }   
 public static String getTextForMessageWithArgs(String messageKey,String [] args){
     String value="["+messageKey+"]";
     try{
       value = ResourceBundle.getBundle(BUNDLE_MESSAGES_NAME).getString(messageKey);
       MessageFormat form = new MessageFormat(value);
       value = form.format(args);
     }
     catch(Exception e){
         e.printStackTrace();
     }
     return value;
 }   

 public static String getTextForLiteral(String messageKey){
     String value="["+messageKey+"]";
     try{
       value = ResourceBundle.getBundle(BUNDLE_LITERALES_NAME).getString(messageKey);
     }
     catch(Exception e){
         e.printStackTrace();
     }
     return value;
 }   
 
 public static void main (String args[]){
     String [] campos = {"pepe"};
     
     System.out.println(Literales.getTextForMessageWithArgs("CampoObligatorio",campos));
 }
}
